;
;  Disassembly by PICDIS V0.3
;  www.picemulator.com
;
;  PICNIC.HEX
;
	__CONFIG _CP_OFF & _WDT_OFF & _HS_OSC & _BODEN_ON & _PWRTE_ON

        LIST   P=PIC16F877
        INCLUDE "P16F877.INC"
        INCLUDE "defs.inc"
;
        ORG     0x0000
;
Begin:
        MOVLW   HIGH Start
        MOVWF   PCLATH
        GOTO    Start & 0x7ff
;
        ORG     0x0004
;
interrupt:
        MOVWF   w_save
        SWAPF   STATUS,W
        CLRF    STATUS
        MOVWF   status_save
        MOVF    PCLATH,W
        MOVWF   pclath_save
        CLRF    PCLATH
        BCF     STATUS,IRP
        MOVF    FSR,W
        MOVWF   fsr_save

;-----------------------------------------------------------------------------------
;		RB0жϴ
        BTFSS   INTCON,INTE
        GOTO    int_next2
        BTFSS   INTCON,INTF
        GOTO    int_next2
        BCF     INTCON,INTF
        BSF     STATUS,RP0
        BSF     STATUS,RP1
        BSF     on_flow,7			; 232
        BCF     STATUS,RP1
        BCF     STATUS,RP0

;-----------------------------------------------------------------------------------
;		ʱжϴ(10ms)
int_next2:
        BTFSC   PIR1,TMR1IF
        GOTO    int_tmr1
        GOTO    int_next1
int_tmr1:
        BCF     PIR1,TMR1IF
        BSF     STATUS,RP0
        MOVF    dhcp_done & 0x7F,W
        ANDLW   0x7F
        BTFSS   STATUS,Z
        DECF    dhcp_done & 0x7F,F
        BCF     STATUS,RP0
int_tmr2:
        BSF     STATUS,RP0
        MOVLW   0x01
        ADDWF   timer & 0x7F,F
        BTFSC   STATUS,C
        GOTO    dec_tm
dec_tm9:
        CLRF    STATUS

;-----------------------------------------------------------------------------------
;		USARTжϴ
int_next1:
        BTFSS   INTCON,PEIE
        GOTO    int2
        BTFSS   PIR1,RCIF			; RS232C?
        GOTO    int2
        BSF     STATUS,RP0
        MOVLW   fifo_bottom - fifo_top
        SUBWF   fifo_cn & 0x7F,W		; buffer overflow ?
        BTFSC   STATUS,C
        GOTO    rec_over

        MOVF    fifo_buff & 0x7F,W
        MOVWF   FSR
        BCF     STATUS,RP0
        MOVF    RCREG,W
        MOVWF   INDF
        BSF     STATUS,RP0
        INCF    fifo_buff & 0x7F,F
        MOVLW   fifo_bottom
        SUBWF   fifo_buff & 0x7F,W
        BTFSS   STATUS,C
        GOTO    int1_1
        MOVLW   fifo_top
        MOVWF   fifo_buff & 0x7F
int1_1:
        INCF    fifo_cn & 0x7F,F
        MOVLW   (fifo_bottom - fifo_top)/2
        SUBWF   fifo_cn & 0x7F,W
        BTFSS   STATUS,C
        GOTO    int2
        BSF     STATUS,RP1
        BTFSS   on_flow,0
        GOTO    int2
        CLRF    STATUS
        BSF     PORTB,1
;	bsf	PORTB,7				; for debug
int2:
        CLRF    STATUS
;-----------------------------------------------------------------------
; 	Contextָ
        MOVF    fsr_save,W
        MOVWF   FSR
        MOVF    pclath_save,W
        MOVWF   PCLATH
        SWAPF   status_save,W
        MOVWF   STATUS
        SWAPF   w_save,F
        SWAPF   w_save,W
        RETFIE
;-----------------------------------------------------------------------------------
;		RS232CŻ
rec_over:
        BCF     STATUS,RP0
        MOVF    RCREG,W
        BCF     STATUS,RP0
        GOTO    int2
;-----------------------------------------------------------------------------------
;		Socketĳʱ
dec_tm:
        BSF     STATUS,IRP
        MOVLW   SOCKETS
        MOVWF   timer_cn & 0x7F
        MOVLW   skb+1
        MOVWF   FSR
dec_tm0:
        MOVF    INDF,W
        ANDLW   0xF0
        BTFSC   STATUS,Z
        GOTO    dec_tm1
        MOVLW   0x10
        SUBWF   INDF,F
        MOVF    INDF,W
        ANDLW   0xF0
        BTFSS   STATUS,Z
        GOTO    dec_tm1
        DECF    FSR,F
        CLRF    INDF
        INCF    FSR,F
dec_tm1:
        MOVLW   0x10
        ADDWF   FSR,F
        DECFSZ  timer_cn & 0x7F,F
        GOTO    dec_tm0
        BCF     STATUS,IRP
        GOTO    dec_tm9

;-----------------------------------------------------------------------------------
;		ȡ16Ƶ
;
getascii:
        ANDLW   0x0F
        ADDWF   PCL,F
        DT      "0123456789ABCDEF"

;-----------------------------------------------------------------------------------
;		seq_noĳʼֵ
next_seq_no:
        BSF     STATUS,RP0
        MOVLW   0x01
        ADDWF   seq_no+2,F
        BTFSC   STATUS,C
        ADDWF   seq_no+3,F
        BCF     STATUS,RP0
        RETURN

;-----------------------------------------------------------------------------------
;		TCPseq_no
inc_seq_no:
        BSF     STATUS,IRP
        MOVLW   0x03
        ADDWF   FSR,F
        MOVLW   0x01
        ADDWF   INDF,F
        DECF    FSR,F
        BTFSC   STATUS,C
        ADDWF   INDF,F
        DECF    FSR,F
        BTFSC   STATUS,C
        ADDWF   INDF,F
        DECF    FSR,F
        BTFSC   STATUS,C
        ADDWF   INDF,F
        BCF     STATUS,IRP
        RETURN

;-----------------------------------------------------------------------------------
;		TCPseq_noip_length
;
add_seq_no
        BSF     STATUS,IRP
        MOVLW   0x03
        ADDWF   FSR,F

        MOVF    ip_length+1,W
        ADDWF   INDF,F
        DECF    FSR,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   INDF,F
        DECF    FSR,F
        BTFSC   STATUS,C
        ADDWF   INDF,F
        DECF    FSR,F
        BTFSC   STATUS,C
        ADDWF   INDF,F

        MOVLW   0x02
        ADDWF   FSR,F
        MOVF    ip_length,W
        ADDWF   INDF,F
        DECF    FSR,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   INDF,F
        DECF    FSR,F
        BTFSC   STATUS,C
        ADDWF   INDF,F
        BCF     STATUS,IRP
        RETURN

;-----------------------------------------------------------------------------------
;		TCPack_no
;
inc_ack_no:
        MOVLW   0x01
        ADDWF   tcp_seq_no+3,F
        BTFSC   STATUS,C
        ADDWF   tcp_seq_no+2,F
        BTFSC   STATUS,C
        ADDWF   tcp_seq_no+1,F
        BTFSC   STATUS,C
        ADDWF   tcp_seq_no,F
        GOTO    copy_ack_no

;-----------------------------------------------------------------------------------
;		TCPack_noip_lengthֵ
;
add_ack_no
        MOVLW   0x28					; 20+20
        SUBWF   ip_length+1,F
        MOVLW   0x01
        BTFSS   STATUS,C
        SUBWF   ip_length,F

        MOVF    ip_length+1,W
        ADDWF   tcp_seq_no+3,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   tcp_seq_no+2,F
        BTFSC   STATUS,C
        ADDWF   tcp_seq_no+1,F
        BTFSC   STATUS,C
        ADDWF   tcp_seq_no,F

        MOVF    ip_length,W
        ADDWF   tcp_seq_no+2,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   tcp_seq_no+1,F
        BTFSC   STATUS,C
        ADDWF   tcp_seq_no,F
copy_ack_no:
        MOVF    com_fsr,W
        MOVWF   FSR
        MOVLW   .12
        ADDWF   FSR,F
        BSF     STATUS,IRP
        MOVF    tcp_seq_no,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_seq_no+1,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_seq_no+2,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_seq_no+3,W
        MOVWF   INDF
        BCF     STATUS,IRP
        RETURN

;-----------------------------------------------------------------------------------
;		checksumֵ
;
clear_sum:
        CLRF    sum
        CLRF    sum+1
        CLRF    bytes
        RETURN


;-----------------------------------------------------------------------------------
;		Error Recovery Routing
;-----------------------------------------------------------------------------------
overflow2
overflow:
        CLRF    STATUS
        CLRF    PORTC
        MOVLW   0x21				; RTL8019AS STOP
        CALL    assert_wr0
        MOVLW   HIGH wait_ms
        MOVWF   PCLATH
        MOVLW   0x02
        MOVWF   wait_cn
        CALL    wait_ms & 0x7ff			; 10ms wait
        CLRF    PCLATH

        MOVLW   0x0A
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0

        MOVLW   0x0B
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0

        CALL    initialize			; ʼRTL8019

        MOVLW   0x0C
        MOVWF   PORTC				; RCR
        MOVLW   b'00000100'
        CALL    assert_wr0			; MONITOR

        MOVLW   0x0D
        MOVWF   PORTC				; TCR
        dw	0x100					; L/B
        CALL    assert_wr0

        GOTO    main0				; ͨĴ

;-----------------------------------------------------------------------------------
;		Main Routing
;-----------------------------------------------------------------------------------
main:
        CLRF    PORTC
        MOVLW   0x22
        CALL    assert_wr0			;PAGE0

        MOVLW   0x0C
        MOVWF   PORTC
        MOVLW   b'00000100'
        CALL    assert_wr0
        MOVLW   0x0D
        MOVWF   PORTC				;TCR
        dw	0x100					;L/B
        CALL    assert_wr0

        MOVLW   HIGH wait_ms
        MOVWF   PCLATH
        MOVLW   .100
        MOVWF   wait_cn
        CALL    wait_ms & 0x7ff			; 100ms Wait
        CLRF    PCLATH

        MOVLW   this_ip
        MOVWF   FSR
        MOVF    INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    main0				;ԼIPַ0.0.0.0 ?
do_dhcp:
        CLRF    STATUS
        MOVLW   HIGH dhcp
        MOVWF   PCLATH
        CALL    dhcp & 0x7ff
        MOVLW   HIGH $
        MOVWF   PCLATH
;-----------------------------------------------------------------------------------
;		Main Loop
;-----------------------------------------------------------------------------------
main0:
        BSF     STATUS,RP0
        MOVLW   0x00
        SUBWF   fifo_cn & 0x7F,W
        BTFSS   STATUS,Z			;RS232C?
        GOTO    receive232c
        MOVLW   0x80
        SUBWF   dhcp_done & 0x7F,W
        BTFSC   STATUS,Z			;DHCP Timeout?
        GOTO    do_dhcp
        BCF     STATUS,RP0

        CLRF    PCLATH
        MOVLW   0x07
        MOVWF   PORTC
        CALL    assert_rd			;RCR Lead

        BTFSC   mdata,4
        GOTO    overflow
        BTFSC   mdata,3
        GOTO    overflow
        BTFSC   mdata,2
        GOTO    overflow
        GOTO    get_packet			;յPacket
main99:
        GOTO    main0

receive232c:
        BCF     STATUS,RP0
        MOVLW   HIGH serial_tx
        MOVWF   PCLATH
        GOTO    serial_tx & 0x7ff		;תRS232Ŵ

;-----------------------------------------------------------------------------------
;		PacketŴ
;-----------------------------------------------------------------------------------
get_packet:
;	PAGE 1
        CLRF    PORTC
        MOVLW   b'01100010'
        CALL    assert_wr0			;ΪPage1

        MOVLW   0x07
        MOVWF   PORTC
        CALL    assert_rd
        MOVF    mdata,W
        MOVWF   curr				;ȡõǰPage
;	PAGE 0
        CLRF    PORTC
        MOVLW   b'00100010'
        CALL    assert_wr0			;Page0

        MOVLW   0x03
        MOVWF   PORTC
        CALL    assert_rd			;BNDY

        INCF    mdata,F				;BNDY++
        MOVLW   PAGE_STOP
        SUBWF   mdata,W
        BTFSS   STATUS,C
        GOTO    packet1				;overlap
        MOVLW   PAGE_START
        MOVWF   mdata
packet1:
        MOVF    curr,W
        SUBWF   mdata,W
        BTFSC   STATUS,Z			;(BNDY+1)==CURRĻ,û
        GOTO    main0				;ж


;-----------------------------------------------------------------------------------
; ȡRTL8019 Status  Ethernet Header
        CLRF    remote_adr
        MOVF    mdata,W
        MOVWF   remote_adr+1
        MOVLW   NE_SIZE+PACKET_SIZE
        MOVWF   remote_len
        CLRF    remote_len+1
        CALL    remote_read

        MOVLW   NE_SIZE+PACKET_SIZE
        MOVWF   gcn1				; Loop Counter
        BCF     STATUS,IRP
        MOVLW   ne_header
        MOVWF   FSR				;ȡne_headerĵַ
        MOVLW   0x10
        MOVWF   PORTC
get_packet0:
        BCF     PORTE,RE0			;RD
        BTFSS   PORTC,RC5			;RDY, ~Wait
        GOTO    $-1
        MOVF    PORTD,W
        BSF     PORTE,RE0
        MOVWF   INDF				;"indirect = data Buffer
        INCF    FSR,F				;FSR++
        DECFSZ  gcn1,F
        GOTO    get_packet0
;
;	Ethernet HeaderĴж
        BSF     STATUS,RP0
        BTFSS   ne_stat,0
        GOTO    main9
        MOVLW   COM_PROTO
        SUBWF   eth_type & 0x7F,W
        BTFSS   STATUS,Z			; typeĸ8bit
        GOTO    main9
        MOVLW   IP_PROTO
        SUBWF   eth_type+1,W
        BTFSC   STATUS,Z
        GOTO    do_ip				;IPЭ
        MOVLW   ARP_PROTO
        SUBWF   eth_type+1,W
        BTFSC   STATUS,Z
        GOTO    do_arp				;ARPЭ
main9:						;
        BCF     STATUS,IRP
        BCF     STATUS,RP1
        BSF     STATUS,RP0
        MOVLW   PAGE_START
        SUBWF   ne_next & 0x7F,W
        BTFSS   STATUS,C
        GOTO    overflow2			;Error Check and Recover
        MOVLW   PAGE_STOP
        SUBWF   ne_next & 0x7F,W
        BTFSC   STATUS,C
        GOTO    overflow			;Error Check and Recover

        DECF    ne_next & 0x7F,F		;һ߽
        MOVLW   PAGE_START
        SUBWF   ne_next & 0x7F,W
        BTFSC   STATUS,C
        GOTO    packet11
        MOVLW   PAGE_STOP-1
        MOVWF   ne_next & 0x7F

packet11:
        BCF     STATUS,RP0

        CLRF    PORTC
        MOVLW   b'00100010'
        CALL    assert_wr0

        MOVLW   0x03
        MOVWF   PORTC
        MOVLW   ne_next
        MOVWF   FSR
        MOVF    INDF,W
        CALL    assert_wr0
        GOTO    main99

;-----------------------------------------------------------------------------------
;		ARPЭ鴦
;-----------------------------------------------------------------------------------
do_arp:
        BCF     STATUS,RP0
        MOVLW   NE_SIZE+PACKET_SIZE
        MOVWF   remote_adr
        MOVLW   ne_cn_l
        MOVWF   FSR
        MOVF    INDF,W
        MOVWF   remote_len
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   remote_len+1
        MOVLW   NE_SIZE+PACKET_SIZE
        SUBWF   remote_len,F
        MOVLW   0x01
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F
        CALL    remote_read

        MOVLW   ip_header			;ip_headerԺ
        MOVWF   FSR
get_packet10:
        MOVF    remote_len,W
        IORWF   remote_len+1,W
        BTFSC   STATUS,Z
        GOTO    get_packet2

        BCF     PORTE,RE0			; RD
        BTFSS   PORTC,RC5			; RDY - ~Wait
        GOTO    $-1
        MOVF    PORTD,W
        BSF     PORTE,RE0			; RD
        MOVWF   INDF
        INCF    FSR,F

        MOVLW   0x01
        SUBWF   remote_len,F
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F
        BTFSS   FSR,7				; Over flow?
        GOTO    get_packet10
;	80hԺ
get_packet20:
        MOVF    remote_len,W
        IORWF   remote_len+1,W
        BTFSC   STATUS,Z
        GOTO    get_packet2			;

        BCF     PORTE,RE0			;RD
        BTFSS   PORTC,RC5			;RDY - ~Wait
        GOTO    $-1
        BSF     PORTE,RE0

        MOVLW   0x01
        SUBWF   remote_len,F
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F
        GOTO    get_packet20
;
;	ARP Header
get_packet2:
        MOVLW   0x00
        SUBWF   arp_ope,W
        BTFSS   STATUS,Z
        GOTO    main9				; arp_codeΪ0001
        MOVLW   0x01
        SUBWF   arp_ope+1,W
        BTFSC   STATUS,Z
        GOTO    arp_req
        MOVLW   0x02
        SUBWF   arp_ope+1,W
        BTFSC   STATUS,Z
        GOTO    arp_reply

        GOTO    main9
arp_reply:
        ; pagesel ser_arp
        MOVLW   HIGH ser_arp
        MOVWF   PCLATH
        GOTO    ser_arp & 0x7ff
arp_req:
arp:
        MOVLW   this_ip				;this_ipBank 1
        MOVWF   FSR

        MOVF    arp_dest_ip,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    main9
        INCF    FSR,F
        MOVF    arp_dest_ip+1,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    main9
        INCF    FSR,F
        MOVF    arp_dest_ip+2,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    main9
        INCF    FSR,F
        MOVF    arp_dest_ip+3,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    main9
;	Ƿ͸ԼARP
        CALL    prepare_ether2

        MOVLW   COM_PROTO			; 08 Etherframe type
        CALL    assert_wr
        MOVLW   ARP_PROTO			; ARP
        CALL    assert_wr

        MOVLW   HIGH arp1
        MOVWF   PCLATH
        CALL    arp1 & 0x7ff
        CLRF    PCLATH

        CLRF    PORTC
        MOVLW   b'00100010'
        CALL    assert_wr0

        MOVLW   0x04
        MOVWF   PORTC
        MOVLW   PAGE_BEGIN			; transmit page is start page
        CALL    assert_wr0

        MOVLW   0x05
        MOVWF   PORTC
        MOVLW   0x3C				; minimum pakcet = 60
        CALL    assert_wr0

        MOVLW   0x06
        MOVWF   PORTC
        dw	0x100					; adr high
        CALL    assert_wr0

        CALL    transmit			;ARPӦ
        GOTO    main9

;-----------------------------------------------------------------------------------
;		IPЭ鴦
;-----------------------------------------------------------------------------------
do_ip:
        BCF     STATUS,RP0
        MOVLW   NE_SIZE+PACKET_SIZE
        MOVWF   remote_adr
        MOVLW   ne_cn_l
        MOVWF   FSR
        MOVF    INDF,W
        MOVWF   remote_len
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   remote_len+1

        MOVLW   NE_SIZE+PACKET_SIZE
        SUBWF   remote_len,F
        MOVLW   0x01
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F
        CALL    remote_read
;
;	IP PacketŴ
        MOVLW   ip_header			;дip_headerַʼ
        MOVWF   FSR
        BCF     PORTE,RE0
        BTFSS   PORTC,RC5
        GOTO    $-1
        MOVF    PORTD,W
        BSF     PORTE,RE0
        MOVWF   INDF				;1byte
        INCF    FSR,F

        MOVLW   0x01
        SUBWF   remote_len,F			;length --
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F

        MOVF    ip_ver_len,W			;ʣByte
        MOVWF   gcn1
        MOVLW   0x0F
        ANDWF   gcn1,F
        BCF     STATUS,C
        RLF     gcn1,F
        RLF     gcn1,F
        DECF    gcn1,F				;IP Header, IP HeaderĴС
        CALL    copy_toram			;͵RAM

ip_get_packet2:
        MOVLW   0x45
        SUBWF   ip_ver_len,W
        BTFSS   STATUS,Z			; IP Version 4?
        GOTO    ip_get_packet9
        MOVLW   TCP_PROTO
        SUBWF   ip_proto,W
        BTFSC   STATUS,Z
        GOTO    tcp				;TCPŴ
        MOVLW   UDP_PROTO
        SUBWF   ip_proto,W
        BTFSC   STATUS,Z
        GOTO    udp				;UDPŴ
        MOVLW   ICMP_PROTO
        SUBWF   ip_proto,W
        BTFSC   STATUS,Z
        GOTO    icmp				;ICMPŴ
ip_get_packet9:
        CALL    abort				;Remote DMAֹ
        GOTO    main9

;-----------------------------------------------------------------------------------
;		gcn1趨
;-----------------------------------------------------------------------------------
copy_toram:
        BCF     PORTE,RE0
        BTFSS   PORTC,RC5
        GOTO    $-1
        MOVF    PORTD,W
        BSF     PORTE,RE0
        MOVWF   INDF
        INCF    FSR,F

        MOVLW   0x01
        SUBWF   remote_len,F
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F
        DECFSZ  gcn1,F
        GOTO    copy_toram
        RETURN

;-----------------------------------------------------------------------------------
;		ʣPacket͵Buffer RAM
;-----------------------------------------------------------------------------------
get_remain:
get_remain0:
        MOVF    remote_len,W
        IORWF   remote_len+1,W
        BTFSC   STATUS,Z
        GOTO    get_remain9			; End ?

        BCF     PORTE,RE0
        BTFSS   PORTC,RC5
        GOTO    $-1
        MOVF    PORTD,W
        BSF     PORTE,RE0
        MOVWF   INDF
        INCF    FSR,F

        MOVLW   0x01
        SUBWF   remote_len,F
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F

        MOVLW   0x90				; 16+128
        ADDWF   FSR,W
        BTFSS   STATUS,C
        GOTO    get_remain0

        MOVLW   0x20
        MOVWF   FSR				;Bank仯ٶ
        BSF     STATUS,IRP

get_remain20:
        MOVF    remote_len,W
        IORWF   remote_len+1,W
        BTFSC   STATUS,Z
        GOTO    get_remain9			;

        BCF     PORTE,RE0
        BTFSS   PORTC,RC5
        GOTO    $-1
        MOVF    PORTD,W
        BSF     PORTE,RE0
        MOVWF   INDF
        INCF    FSR,F

        MOVLW   0x01
        SUBWF   remote_len,F
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F

        MOVLW   0x90				; 16+128
        ADDWF   FSR,W
        BTFSS   STATUS,C
        GOTO    get_remain20

get_remain30
        CALL    abort

get_remain9:
        BCF     STATUS,IRP
        RETURN

;-----------------------------------------------------------------------------------
;		ICMPЭ鴦
;-----------------------------------------------------------------------------------
icmp:
        CALL    get_remain			;RTL8019жȡ
        MOVLW   0x08
        SUBWF   icmp_type,W
        BTFSS   STATUS,Z
        GOTO    main9				;typeΪ08
        MOVLW   0x00
        SUBWF   icmp_code,W
        BTFSS   STATUS,Z
        GOTO    main9				;codeΪ0

ping
        MOVLW   ICMP_PROTO
        MOVWF   proto				;Protocol=ICMP
        CALL    prepare_ip			;׼IP Packet

        MOVLW   PACKET_SIZE+IP_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        MOVF    ip_length+1,W			; ne_cn_l
        MOVWF   remote_len
        MOVLW   IP_SIZE-1
        SUBWF   remote_len,F
        CLRF    remote_len+1
        CALL    remote_write

        CALL    clear_sum			;checksum

        MOVLW   0x10
        MOVWF   PORTC
        CALL    assert_wr2times			;type : code
        CALL    assert_wr2times			;sum High : Low

        MOVF    ip_length+1,W
        MOVWF   gcn1
        MOVLW   IP_SIZE+4
        SUBWF   gcn1,F
        MOVLW   icmp_header+4
        MOVWF   FSR
icmp10:
        MOVF    INDF,W
        INCF    FSR,F
        CALL    assert_wr

        MOVLW   0x90
        ADDWF   FSR,W
        BTFSC   STATUS,C
        GOTO    icmp20
icmp19:
        DECFSZ  gcn1,F
        GOTO    icmp10
        BCF     STATUS,IRP

        dw	0x100
        CALL    assert_wr

        MOVLW   PACKET_SIZE+IP_SIZE+2
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        CALL    set_checksum

        MOVLW   0x04
        MOVWF   PORTC
        MOVLW   PAGE_BEGIN
        CALL    assert_wr0

        MOVLW   0x05
        MOVWF   PORTC
        MOVLW   ne_cn_l
        MOVWF   FSR
        MOVF    INDF,W
        CALL    assert_wr0

        MOVLW   0x06
        MOVWF   PORTC
        INCF    FSR,F
        MOVF    INDF,W
        CALL    assert_wr0

        CALL    transmit			;pingӦ
        GOTO    main9
icmp20:
        MOVLW   0x20
        MOVWF   FSR
        BSF     STATUS,IRP
        GOTO    icmp19

;-----------------------------------------------------------------------------------
;		UDP
;-----------------------------------------------------------------------------------
udp:
        MOVLW   0x08
        MOVWF   gcn1
        CALL    copy_toram

; BOOTP Portļ
        MOVLW   0x00
        SUBWF   tcp_tar_port,W
        BTFSS   STATUS,Z
        GOTO    udp_1
        MOVLW   BOOTPC_PORT & 0xff
        SUBWF   tcp_tar_port+1,W
        BTFSC   STATUS,Z
        GOTO    bootp_res			; BOOTP

        MOVLW   this_ip
        MOVWF   FSR
        MOVF    INDF,W
        SUBWF   ip_dest,W
        BTFSS   STATUS,Z
        GOTO    main9
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   ip_dest+1,W
        BTFSS   STATUS,Z
        GOTO    main9
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   ip_dest+2,W
        BTFSS   STATUS,Z
        GOTO    main9
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   ip_dest+3,W
        BTFSS   STATUS,Z
        GOTO    main9
; LCD Port
udp_1:
        MOVLW   lcd_port & 0xff
        MOVWF   FSR
        MOVF    INDF,W
        SUBWF   tcp_tar_port,W
        BTFSS   STATUS,Z
        GOTO    udp_2
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   tcp_tar_port+1,W
        BTFSC   STATUS,Z
        GOTO    udp_lcd_tag
udp_2:
        MOVLW   para_port & 0xff
        MOVWF   FSR
        MOVF    INDF,W
        SUBWF   tcp_tar_port,W
        BTFSS   STATUS,Z
        GOTO    udp_3
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   tcp_tar_port+1,W
        BTFSC   STATUS,Z
        GOTO    udp_parallel_tag
udp_3:
        MOVLW   serial_port & 0xff
        MOVWF   FSR
        MOVF    INDF,W
        SUBWF   tcp_tar_port,W
        BTFSS   STATUS,Z
        GOTO    udp_4
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   tcp_tar_port+1,W
        BTFSC   STATUS,Z
        GOTO    udp_serial_tag
udp_4:
;
; add new function here
;
        GOTO    main9

udp_lcd_tag:
        MOVLW   HIGH udp_lcd
        MOVWF   PCLATH
        GOTO    udp_lcd & 0x7ff

;
; Parallel I/O (UDP)
udp_parallel_tag:
        MOVLW   udp_data
        MOVWF   FSR
        CALL    get_remain
        MOVLW   HIGH udp_parallel
        MOVWF   PCLATH
        GOTO    udp_parallel & 0x7ff

udp_serial_tag:
        MOVLW   HIGH udp_serial
        MOVWF   PCLATH
        GOTO    udp_serial & 0x7ff

;-----------------------------------------------------------------------------------
get_dgram:
        MOVF    remote_len,W
        IORWF   remote_len+1,W
        BTFSC   STATUS,Z
        GOTO    get_dgram9

        BCF     PORTE,RE0
        BTFSS   PORTC,RC5
        GOTO    $-1
        MOVF    PORTD,W
        BSF     PORTE,RE0
        MOVWF   mdata

        MOVLW   0x01
        SUBWF   remote_len,F
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F
        BCF     STATUS,C			; OK
        RETURN
get_dgram9:
        BSF     STATUS,C			; EOT
        RETURN

;-----------------------------------------------------------------------------------
;		BOOTPӦ
;-----------------------------------------------------------------------------------
bootp_res:
        CALL    get_remain

        MOVLW   this_ip
        MOVWF   FSR
        MOVF    INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    main9

        MOVLW   HIGH bootp
        MOVWF   PCLATH
        CALL    bootp & 0x7ff
        MOVLW   HIGH $
        MOVWF   PCLATH

        MOVLW   0x35
        CALL    assert_wr
        MOVLW   0x01
        CALL    assert_wr
        MOVLW   0x03				;request
        CALL    assert_wr

        MOVLW   0x3D
        CALL    assert_wr
        MOVLW   0x07
        CALL    assert_wr
        MOVLW   0x01
        CALL    assert_wr
        MOVLW   mymac
        MOVWF   FSR

        MOVLW   0x06
        CALL    transmit_nbytes			;ԼIPַ

        MOVLW   0x36
        CALL    assert_wr
        MOVLW   0x04
        CALL    assert_wr
        MOVLW   0xC0
        CALL    assert_wr
        MOVLW   0xA8
        CALL    assert_wr
        MOVLW   0x00
        CALL    assert_wr
        MOVLW   0x03
        CALL    assert_wr

        MOVLW   0x32
        CALL    assert_wr
        MOVLW   0x04
        CALL    assert_wr

        MOVLW   dhcp_user_ip
        MOVWF   FSR
        MOVLW   0x04
        CALL    transmit_nbytes

        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0x23
        MOVWF   gcn1
bootp_40:
        dw	0x100
        CALL    assert_wr
        DECFSZ  gcn1,F
        GOTO    bootp_40

        MOVLW   HIGH bootp_tx
        MOVWF   PCLATH
        CALL    bootp_tx & 0x7ff
        MOVLW   HIGH $
        MOVWF   PCLATH

        MOVLW   this_ip
        MOVWF   FSR
        MOVF    dhcp_user_ip,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    dhcp_user_ip+1,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    dhcp_user_ip+2,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    dhcp_user_ip+3,W
        MOVWF   INDF
        BSF     STATUS,RP0
        CLRF    dhcp_done & 0x7F
        BCF     STATUS,RP0
;
; LCDʾȡõIPַ
        BCF     PORTB,RB2			;RS
        MOVLW   0xC0
        MOVWF   d4
        MOVLW   HIGH write_lcd4
        MOVWF   PCLATH
        CALL    write_lcd4 & 0x7ff		;ƶ2

        MOVLW   HIGH print_ip
        MOVWF   PCLATH
        CALL    print_ip & 0x7ff		;ʾ

        CLRF    PORTB
        CLRF    PCLATH
        GOTO    main9

;-----------------------------------------------------------------------------------
;		ԣã
;-----------------------------------------------------------------------------------
tcp:
        MOVLW   0x14
        MOVWF   gcn1				;ȡ20 bytes
        CALL    copy_toram

        MOVLW   http_port
        MOVWF   FSR

        MOVF    INDF,W
        SUBWF   tcp_tar_port,W
        BTFSS   STATUS,Z			; EEPROMеHTTP Portһ?
        GOTO    tcp9
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   tcp_tar_port+1,W
        BTFSC   STATUS,Z
        GOTO    tcp_www
tcp9:
        GOTO    main9
;
;	HTTP
;
tcp_www:
        MOVLW   this_ip				;ǷԼIPַ
        MOVWF   FSR
        MOVF    INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        BTFSC   STATUS,Z
        GOTO    main9				;0.0.0.0Ļֹ

        BTFSC   TCP_URG				;URG
        GOTO    main9				;

        MOVLW   HIGH search_socket
        MOVWF   PCLATH
        CALL    search_socket & 0x7ff		; Socket
        MOVLW   HIGH $
        MOVWF   PCLATH
        BTFSC   STATUS,C
        GOTO    state1

        CALL    no_socket			;Socket
        GOTO    main9
;
;	Socket State 1
;
state1:
        MOVLW   0x0C
        ADDWF   FSR,F
        MOVF    INDF,W
        SUBWF   tcp_seq_no,W
        BTFSS   STATUS,Z
        GOTO    state12
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   tcp_seq_no+1,W
        BTFSS   STATUS,Z
        GOTO    state12
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   tcp_seq_no+2,W
        BTFSS   STATUS,Z
        GOTO    state12
        INCF    FSR,F
        MOVF    INDF,W
        SUBWF   tcp_seq_no+3,W
        BTFSS   STATUS,Z
        GOTO    state12
        MOVLW   0x0F
        SUBWF   FSR,F

        CALL    state2
state12:
        CLRF    PCLATH
        GOTO    main9
state2:
        MOVLW   HIGH state_table
        MOVWF   PCLATH
        MOVF    INDF,W
        ANDLW   0x7F
        ADDWF   PCL,F
state_table
        GOTO    job_SYN_RCVD
        GOTO    job_ESTAB
        GOTO    job_CLOSE_WAIT
        GOTO    main9
        GOTO    job_FIN_WAIT_1
        GOTO    job_FIN_WAIT_2
        GOTO    main9
        GOTO    main9
        GOTO    main9				;ACK,PSH,RST,SYN,FIN

;-----------------------------------------------------------------------------------
;	յSYN
;	SYN,ACK,ȴACK
;-----------------------------------------------------------------------------------
job_SYN_RCVD:

        BTFSC   TCP_RST
        GOTO    recv_rst
        BTFSC   TCP_FIN
        GOTO    recv_fin
        BTFSS   TCP_ACK
        RETURN

        MOVLW   ESTAB
        MOVWF   INDF
        BCF     STATUS,IRP
        RETURN

recv_rst
        CLRF    INDF
        BCF     STATUS,IRP
        RETURN

;-----------------------------------------------------------------------------------
;
job_FIN_WAIT_1:
        BTFSC   TCP_RST
        GOTO    recv_rst
        BTFSS   TCP_ACK
        RETURN

        MOVLW   FIN_WAIT_2
        MOVWF   INDF
        BCF     STATUS,IRP
        RETURN

;-----------------------------------------------------------------------------------
;
job_FIN_WAIT_2:
        BTFSC   TCP_RST
        GOTO    recv_rst
        BTFSS   TCP_FIN
        RETURN

        CLRF    INDF
        BCF     STATUS,IRP
        CALL    inc_ack_no
        CALL    send_ack
        RETURN


;-----------------------------------------------------------------------------------
;
        NOP
job_ESTAB:
        BTFSC   TCP_RST
        GOTO    recv_rst
        BTFSC   TCP_FIN
        GOTO    recv_fin

        INCF    FSR,F
        MOVLW   HIGH $
        MOVWF   PCLATH
        MOVF    INDF,W
        ANDLW   0x0F
        ADDWF   PCL,F
        GOTO    ESTAB_00
        GOTO    ESTAB_01
        GOTO    ESTAB_02
        GOTO    ESTAB_03
        GOTO    ESTAB_99

recv_fin:
        MOVLW   0x00
        MOVWF   INDF
        BCF     STATUS,IRP
        CALL    inc_ack_no
        CALL    send_ack
        RETURN


;-----------------------------------------------------------------------------------
;
job_CLOSE_WAIT:
        MOVLW   0x00
        MOVWF   INDF
        BCF     STATUS,IRP
        CALL    send_fin
        RETURN

ESTAB_99
        DECF    FSR,F
        MOVLW   FIN_WAIT_1
        MOVWF   INDF
        BCF     STATUS,IRP

        CALL    send_fin

        MOVF    com_fsr,W
        MOVWF   FSR
        MOVLW   0x08
        ADDWF   FSR,F
        CALL    inc_seq_no
        RETURN

;-----------------------------------------------------------------------------------
;	ESTABLISH
;
ESTAB_00:
        INCF    INDF,F
        BCF     STATUS,IRP
estab0
        MOVLW   HIGH get_nextbyte
        MOVWF   PCLATH
        CALL    get_nextbyte			;bufferȡ
        MOVLW   HIGH $
        MOVWF   PCLATH

        MOVLW   0x00
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    estab1				;?
        MOVLW   0x0A
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    estab1				;з?
        MOVLW   '?'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse_cgi_tag			;'?'ַ?(=GET)
        GOTO    estab0
parse9
;-----------------------------------------------------------------------------------
;
estab1
        CALL    abort				;ֹBuffer
        CALL    add_ack_no			;ACK NO

        MOVLW   0x14
        MOVWF   wk				;Bank Address = 14h
        GOTO    send_mes			;
;
;	Bankת
parse_cgi_tag
        MOVLW   HIGH parse_cgi
        MOVWF   PCLATH
        GOTO    parse_cgi

ESTAB_01
        INCF    INDF,F
        BCF     STATUS,IRP
        MOVLW   0x17
        MOVWF   wk
        GOTO    send_mes			;
ESTAB_02
        INCF    INDF,F
        BCF     STATUS,IRP
        MOVLW   0x1A
        MOVWF   wk
        GOTO    send_mes			;
ESTAB_03
        INCF    INDF,F
        BCF     STATUS,IRP
        MOVLW   0x1D
        MOVWF   wk
        GOTO    send_mes			;

;
;	ֹRemote DMA
;
abort:
        CLRF    PORTC
        MOVLW   0x22
        CALL    assert_wr0			;صPAGE0

        MOVLW   0x0A
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0

        MOVLW   0x0B
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0
        RETURN

;-----------------------------------------------------------------------------------
;	RST
send_rst:
        MOVLW   b'00000100'			;RST
        MOVWF   state
        GOTO    send_common

;-----------------------------------------------------------------------------------
;	FIN
send_fin
        MOVLW   b'00010001'			;ACK+FIN
        MOVWF   state
        GOTO    send_common

;-----------------------------------------------------------------------------------
;	ACK
send_ack
        MOVLW   b'00010000'			;ACK
        MOVWF   state
send_common:
        MOVLW   0x00
        MOVWF   ip_length
        MOVLW   IP_SIZE + TCP_SIZE
        MOVWF   ip_length+1

        MOVLW   TCP_PROTO
        MOVWF   proto				;TCP packet
        CALL    prepare_ip

        MOVLW   PACKET_SIZE+IP_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        MOVLW   0x14
        MOVWF   remote_len
        MOVLW   0x00
        MOVWF   remote_len+1
        CALL    remote_write

        CALL    clear_sum

        MOVLW   http_port
        MOVWF   FSR
        MOVLW   0x02
        CALL    transmit_nbytes			;ԼPort

        MOVLW   tcp_src_port
        MOVWF   FSR
        MOVLW   0x02
        CALL    transmit_nbytes			;ԷPort

        MOVF    com_fsr,W
        MOVWF   FSR
        MOVLW   0x08
        ADDWF   FSR,F
        BSF     STATUS,IRP
        MOVLW   0x08
        CALL    transmit_nbytes			;ԼSeq No
        BCF     STATUS,IRP

        MOVLW   0x50				;20 bytes
        CALL    assert_wr
        MOVF    state,W
        CALL    assert_wr

        MOVLW   0x08				;window(high)
        CALL    assert_wr
        MOVLW   0x00				;window(low)
        CALL    assert_wr

        CALL    assert_wr2times			;tcp sum
        CALL    assert_wr2times			;point

        CALL    calc_tcp_sum			;tcp sum

        MOVLW   0x04
        MOVWF   PORTC
        MOVLW   PAGE_BEGIN			;transmit page is start page
        CALL    assert_wr0

        MOVLW   0x05
        MOVWF   PORTC
        MOVLW   0x3C				;60 bytes
        CALL    assert_wr0

        MOVLW   0x06
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0
        CALL    transmit			;
        RETURN

;-----------------------------------------------------------------------------------
;
send_mes:
        MOVLW   LOW assert_wr2x			;RTL8019
        MOVWF   dest
        MOVLW   HIGH assert_wr2x
        MOVWF   dest+1

send_mes_head
        MOVLW   PACKET_SIZE+IP_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        MOVLW   0xFF
        MOVWF   remote_len
        MOVLW   0xFF
        MOVWF   remote_len+1
        CALL    remote_write

        CLRF    remote_len
        CLRF    remote_len+1

        CALL    clear_sum

        MOVLW   http_port
        MOVWF   FSR
        MOVLW   0x02
        CALL    transmit_nbytes2

        MOVLW   tcp_src_port
        MOVWF   FSR
        MOVLW   0x02
        CALL    transmit_nbytes2

        BSF     STATUS,IRP
        MOVF    com_fsr,W
        MOVWF   FSR
        MOVLW   0x08
        ADDWF   FSR,F
        MOVLW   0x04
        CALL    transmit_nbytes2
        BCF     STATUS,IRP

        MOVLW   tcp_seq_no
        MOVWF   FSR
        MOVLW   0x04
        CALL    transmit_nbytes2

        MOVLW   0x50
        CALL    assert_wr2
        MOVLW   0x18
        CALL    assert_wr2

        MOVLW   0x08
        CALL    assert_wr2
        MOVLW   0x00
        CALL    assert_wr2

        dw	0x100
        CALL    assert_wr2
        dw	0x100
        CALL    assert_wr2
        dw	0x100
        CALL    assert_wr2
        dw	0x100
        CALL    assert_wr2

        CLRF    ind
        BSF     STATUS,RP1
        BCF     STATUS,RP0
        MOVF    wk,W
        MOVWF   EEADRH
send_mes0
        BSF     STATUS,RP1
        BCF     STATUS,RP0
        MOVF    ind,W
        MOVWF   EEADR
        BSF     STATUS,RP0
        BSF     EECON1,EEPGD
        BSF     EECON1,RD			;Code Area
        NOP
        NOP
        BCF     STATUS,RP0
        MOVF    EEDATH,W
        MOVWF   getmes_wk			;ƶҵ
        MOVF    EEDATA,W
        MOVWF   getmes_wk+1
        BCF     STATUS,RP1

        RLF     getmes_wk+1,W
        RLF     getmes_wk,F
        MOVF    getmes_wk,W
        MOVWF   mdata
        MOVLW   0x7F
        ANDWF   mdata,F
        MOVF    mdata,F
        BTFSC   STATUS,Z
        GOTO    send_mes9			;λΪ0
;
;
        MOVLW   '$'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    ctrl_code2
        MOVLW   '@'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    ctrl_code3
        MOVLW   '%'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    ctrl_code4
        MOVLW   '~'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    ctrl_code5			;Socket Status
        MOVF    mdata,W
        CALL    assert_wr2

        MOVF    getmes_wk+1,W
        ANDLW   0x7F
        CALL    assert_wr2

        MOVLW   0x01
        ADDWF   ind,F
        BSF     STATUS,RP1
        BCF     STATUS,RP0
        BTFSC   STATUS,C
        INCF    EEADRH,F
        GOTO    send_mes0
send_mes9

send_mes_foot
        CALL    abort				;ֹͣRemote DMA

        MOVF    remote_len,W
        MOVWF   ip_length+1
        MOVF    remote_len+1,W
        MOVWF   ip_length

        CALL    calc_tcp_sum

        MOVLW   0x14
        ADDWF   ip_length+1,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   ip_length,F

        MOVLW   TCP_PROTO			;TCP Packet
        MOVWF   proto
        CALL    prepare_ip			;׼IP Protocol

        MOVLW   0x04
        MOVWF   PORTC
        MOVLW   PAGE_BEGIN			;transmit page is start page
        CALL    assert_wr0

        MOVLW   PACKET_SIZE
        ADDWF   ip_length+1,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   ip_length

        MOVLW   0x06
        MOVWF   PORTC
        MOVF    ip_length,W			;HIGH
        CALL    assert_wr0
        MOVF    ip_length,F
        BTFSC   STATUS,Z
        GOTO    send_mes_foot1
send_mes_foot2:
        MOVLW   0x05
        MOVWF   PORTC
        MOVF    ip_length+1,W
        CALL    assert_wr0
        CALL    transmit			;

;	Additional Code
send_mes_foot3
        MOVLW   PACKET_SIZE+IP_SIZE+TCP_SIZE
        SUBWF   ip_length+1,F
        MOVLW   0x01
        BTFSS   STATUS,C
        SUBWF   ip_length,F

        MOVF    com_fsr,W
        MOVWF   FSR
        MOVLW   0x08
        ADDWF   FSR,F
        CALL    add_seq_no
        RETURN

send_mes_foot1:
        MOVLW   0x3C
        SUBWF   ip_length+1,W
        BTFSC   STATUS,C
        GOTO    send_mes_foot2

        MOVLW   0x05
        MOVWF   PORTC
        MOVLW   0x3C				;Minimum 60 bytes
        CALL    assert_wr0
        CALL    transmit
        GOTO    send_mes_foot3


;-----------------------------------------------------------------------------------
;		AD任
;
ad_in
        RLF     getmes_wk+1,F
        RLF     getmes_wk+1,F
        RLF     getmes_wk+1,F
        MOVLW   0x38
        ANDWF   getmes_wk+1,F
        MOVLW   0x81
        IORWF   getmes_wk+1,F
        MOVF    getmes_wk+1,W
        MOVWF   ADCON1

        MOVLW   0x01
        MOVWF   wait_cn
        MOVLW   HIGH wait_ms
        MOVWF   PCLATH
        CALL    wait_ms				;ȴ20usĲʱ
        MOVLW   HIGH $
        MOVWF   PCLATH

        BSF     ADCON1,2			;AD任ʼ
        BTFSC   ADCON1,2			;ȴAD任
        GOTO    $-1

        MOVF    ADRESH,W
        MOVWF   val+1
        BSF     STATUS,RP0
        MOVF    ADRESL,W
        BCF     STATUS,RP0
        MOVWF   val

        BTFSS   getmes_wk+1,5			;RA5?
        GOTO    ad_in1				;RA5
;
;	AD任Ľ5
;
        BCF     STATUS,C
        RLF     val,F
        RLF     val+1,F
        BCF     STATUS,C
        RLF     val,F
        RLF     val+1,F

        MOVF    ADRESH,W
        ADDWF   val+1,F
        BSF     STATUS,RP0
        MOVF    ADRESL,W
        BCF     STATUS,RP0
        ADDWF   val,F
        BTFSC   STATUS,C
        INCF    val+1,F

        MOVLW   decimal_top
        MOVWF   FSR
        BSF     STATUS,IRP
        MOVLW   HIGH divide16
        MOVWF   PCLATH
        CALL    divide16
ad_in1
        MOVLW   HIGH put_decimal16
        MOVWF   PCLATH
        CALL    put_decimal16
        MOVLW   HIGH $
        MOVWF   PCLATH
        GOTO    ctrl_next

;-----------------------------------------------------------------------------------
;	SOCKET STATUS
ctrl_code5
        MOVLW   0x7F
        ANDWF   getmes_wk+1,F
        SWAPF   getmes_wk+1,F
        MOVF    getmes_wk+1,W
        MOVWF   FSR
        BSF     STATUS,IRP
        BCF     STATUS,IRP
        GOTO    ctrl_next

;-----------------------------------------------------------------------------------
;	TRIS
;	/ʾ
ctrl_code4
        MOVLW   0x7F
        ANDWF   getmes_wk+1,F
        MOVF    getmes_wk+1,W
        MOVWF   FSR
        SWAPF   FSR,F
        MOVLW   0x0F
        ANDWF   FSR,F
        MOVLW   PORTA | 0x80
        ADDWF   FSR,F

        MOVF    getmes_wk+1,W
        CALL    getbitpos
        MOVF    INDF,W
        ANDWF   mdata,F
        BTFSC   STATUS,Z
        GOTO    ctrl_out
        GOTO    ctrl_in

;
;bitλ
getbitpos:
        MOVWF   wk
        MOVLW   0x01
        MOVWF   mdata
        MOVLW   0x07
        ANDWF   wk,F
        BTFSC   STATUS,Z
        GOTO    getbitpos9
getbitpos0
        BCF     STATUS,C
        RLF     mdata,F
        DECFSZ  wk,F
        GOTO    getbitpos0
getbitpos9
        RETURN

;-----------------------------------------------------------------------------------
;	PARALLEL
;	ʾڵHigh/Low
ctrl_code3
        MOVLW   0x7F
        ANDWF   getmes_wk+1,F
        MOVF    getmes_wk+1,W
        MOVWF   FSR
        SWAPF   FSR,F
        MOVLW   0x0F
        ANDWF   FSR,F
        BTFSS   STATUS,Z
        GOTO    ctrl_code31

        MOVLW   PORTA | 0x80
        ADDWF   FSR,F
        MOVF    getmes_wk+1,W
        CALL    getbitpos

        MOVF    INDF,W
        ANDWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    ctrl_code32

        MOVLW   HIGH getadtable
        MOVWF   PCLATH
        CALL    getadtable
        MOVWF   wk
        MOVLW   HIGH $
        MOVWF   PCLATH

        MOVF    wk,W
        ANDWF   mdata,F
        BTFSS   STATUS,Z
        GOTO    ad_in
ctrl_code32
        CLRF    FSR
ctrl_code31
        MOVLW   PORTA
        ADDWF   FSR,F
        MOVF    getmes_wk+1,W
        CALL    getbitpos
        MOVF    INDF,W
        ANDWF   mdata,F
        BTFSC   STATUS,Z
        GOTO    ctrl_low
        GOTO    ctrl_high

;-----------------------------------------------------------------------------------
;	ȡöϢ
get_short_mes
        MOVLW   0x1F				;ûñ?
        MOVWF   PCLATH
        MOVF    wk,W
        MOVWF   PCL

ctrl_out
        MOVLW   mes_out				;'OUT'
        GOTO    put_short_mes10
ctrl_in
        MOVLW   mes_in				;'IN'
        GOTO    put_short_mes10
ctrl_high
        MOVLW   mes_high			;'HIGH'
        GOTO    put_short_mes10
ctrl_low
        MOVLW   mes_low				;'LOW'
        GOTO    put_short_mes10
put_short_mes10
        MOVWF   wk
put_short_mes0
        CALL    get_short_mes
        MOVWF   mdata
        MOVLW   HIGH $
        MOVWF   PCLATH				;PCLATH

        MOVLW   0x00
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    ctrl_next			;NULL?
        MOVF    mdata,W
        CALL    assert_wr2			;͵RTL8019

        INCF    wk,F
        GOTO    put_short_mes0

;
;		META CHARACTER
ctrl_code2
        MOVLW   HIGH ctrl_code1
        MOVWF   PCLATH
        MOVF    getmes_wk+1,W
        ANDLW   0x7F
        ADDLW   0xD0

        CALL    ctrl_code1			;ÿƷ
        MOVLW   HIGH $
        MOVWF   PCLATH
ctrl_next
        MOVLW   0x01
        ADDWF   ind,F
        BSF     STATUS,RP1
        BCF     STATUS,RP0
        BTFSC   STATUS,C
        INCF    EEADRH,F
        GOTO    send_mes0

;-----------------------------------------------------------------------------------
;		Socket
;
no_socket:
        BTFSS   TCP_SYN
        RETURN
;
;	SYN Packet -> SYN+ACK
;
recv_syn
        MOVLW   HIGH socket_entry
        MOVWF   PCLATH
        CALL    socket_entry & 0x7ff		;Socket Entry
        MOVLW   HIGH $
        MOVWF   PCLATH
        BTFSC   STATUS,C
        GOTO    send_rst

        MOVLW   0x00
        MOVWF   ip_length
        MOVLW   0x2C
        MOVWF   ip_length+1

        MOVLW   TCP_PROTO
        MOVWF   proto
        CALL    prepare_ip

        MOVLW   PACKET_SIZE + IP_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        MOVLW   0x18
        MOVWF   remote_len
        MOVLW   0x00
        MOVWF   remote_len+1
        CALL    remote_write

        CALL    clear_sum

        MOVLW   http_port
        MOVWF   FSR
        MOVLW   0x02
        CALL    transmit_nbytes

        MOVLW   tcp_src_port
        MOVWF   FSR
        MOVLW   0x02
        CALL    transmit_nbytes

        MOVLW   seq_no
        MOVWF   FSR
        MOVLW   0x04
        CALL    transmit_nbytes

        CALL    inc_ack_no

        MOVF    com_fsr,W
        MOVWF   FSR
        MOVLW   0x08
        ADDWF   FSR,F

        BSF     STATUS,IRP
        BSF     STATUS,RP0
        MOVF    seq_no & 0x7F,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    seq_no+1,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    seq_no+2,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    seq_no+3,W
        MOVWF   INDF
        INCF    FSR,F
        BCF     STATUS,RP0

        MOVF    tcp_seq_no,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_seq_no+1,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_seq_no+2,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_seq_no+3,W
        MOVWF   INDF
        BCF     STATUS,IRP

        MOVF    com_fsr,W
        MOVWF   FSR
        MOVLW   0x08
        ADDWF   FSR,F
        CALL    inc_seq_no

        MOVLW   tcp_seq_no
        MOVWF   FSR
        MOVLW   0x04
        CALL    transmit_nbytes

        MOVLW   0x60				;Option
        CALL    assert_wr
        MOVLW   0x12				;ACK+SYN
        CALL    assert_wr

        MOVLW   0x08				;window(high)
        CALL    assert_wr
        MOVLW   0x00				;window(low)
        CALL    assert_wr

        CALL    assert_wr2times			;tcp sum
        CALL    assert_wr2times

        MOVLW   0x02
        CALL    assert_wr
        MOVLW   0x04
        CALL    assert_wr
        MOVLW   0x05
        CALL    assert_wr
        MOVLW   0xB4
        CALL    assert_wr

        CALL    calc_tcp_sum			;TCPSUM

        MOVLW   0x04
        MOVWF   PORTC
        MOVLW   PAGE_BEGIN
        CALL    assert_wr0

        MOVLW   0x05
        MOVWF   PORTC
        MOVLW   0x3C
        CALL    assert_wr0

        MOVLW   0x06
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0
        CALL    transmit
        CALL    next_seq_no			;seq_no ++
        RETURN

;-----------------------------------------------------------------------------------
;		Checksum
calc_tcp_sum:
        CLRF    bytes				;2byte

        MOVLW   this_ip				;ԼIPַ
        MOVWF   FSR
        MOVF    INDF,W
        CALL    calc_sum
        INCF    FSR,F
        MOVF    INDF,W
        CALL    calc_sum
        INCF    FSR,F
        MOVF    INDF,W
        CALL    calc_sum
        INCF    FSR,F
        MOVF    INDF,W
        CALL    calc_sum

        MOVF    ip_src,W			;ԷIPַ
        CALL    calc_sum
        MOVF    ip_src+1,W
        CALL    calc_sum
        MOVF    ip_src+2,W
        CALL    calc_sum
        MOVF    ip_src+3,W
        CALL    calc_sum

        dw	0x100					;Э
        CALL    calc_sum
        MOVLW   TCP_PROTO
        CALL    calc_sum

        MOVF    remote_len+1,W			;byte
        CALL    calc_sum
        MOVF    remote_len,W
        CALL    calc_sum

        MOVLW   0x32				;PACKET_SIZE + IP_SIZE + 16
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        CALL    set_checksum			;õRTL8019Buffer
        RETURN

;===================================================================================
;		ʼNIC
;===================================================================================
initialize:
        CALL    init_nic			;Reset NIC
        CALL    getmac				;ȡMACַ
        CALL    setmac				;MACַ
;	ʼRingBuffer
        BSF     STATUS,RP0
        MOVLW   fifo_top
        MOVWF   fifo_buff & 0x7F
        MOVWF   fifo_poi & 0x7F
        MOVWF   fifo_bottom & 0x7F

        CLRF    fifo_cn & 0x7F
        CLRF    fifo_line_cn & 0x7F
        BCF     STATUS,RP0

        RETURN

;-----------------------------------------------------------------------------------
;		RTL8019Reset
;-----------------------------------------------------------------------------------
reset_nic:
        CLRF    PORTC
        MOVLW   0x21
        CALL    assert_wr0			;STOP OPERATION

        MOVLW   0x1F
        MOVWF   PORTC
        CALL    assert_rd			;1Fh

        MOVLW   0x1F
        MOVWF   PORTC
        MOVF    mdata,W
        CALL    assert_wr0			;д1Fh
reset_nic0:
        MOVLW   0x07
        MOVWF   PORTC
        CALL    assert_rd			;Status
        BTFSS   mdata,7
        GOTO    reset_nic0			;ResetǷѾ
        RETURN

;-----------------------------------------------------------------------------------
;		ʼRTL8019
;-----------------------------------------------------------------------------------
init_nic:
        CALL    reset_nic

        MOVLW   0x0E
        MOVWF   PORTC				;DCR(Data Configuration Register)
        MOVLW   0x68
        CALL    assert_wr0

        MOVLW   0x0A
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0			;for over flow

        MOVLW   0x0B
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0			;for over flow

        MOVLW   0x01
        MOVWF   PORTC
        MOVLW   PAGE_START			;PAGE START
        CALL    assert_wr0

        MOVLW   0x02
        MOVWF   PORTC
        MOVLW   PAGE_STOP			;PAGE STOP
        CALL    assert_wr0

        MOVLW   0x03
        MOVWF   PORTC
        MOVLW   PAGE_START			;BDRY
        CALL    assert_wr0

        MOVLW   0x0C
        MOVWF   PORTC				;RCR
        MOVLW   0x00
        CALL    assert_wr0

        MOVLW   0x0D
        MOVWF   PORTC				;TCR
        MOVLW   0x02				;Loop Back
        CALL    assert_wr0

        MOVLW   0x0F				;IMR
        MOVWF   PORTC
        MOVLW   0x1F
        CALL    assert_wr0

        MOVLW   0x07				;ISR
        MOVWF   PORTC
        MOVLW   0xFF
        CALL    assert_wr0

        CLRF    PORTC				;CR(Command Register)
        MOVLW   0x22				;START OPERATION with L/B
        CALL    assert_wr0
        RETURN

;-----------------------------------------------------------------------------------
;		ȡMACַ
;-----------------------------------------------------------------------------------
getmac:
        CLRF    PORTC
        MOVLW   0x22
        CALL    assert_wr0

        CLRF    remote_adr
        CLRF    remote_adr+1
        MOVLW   .12				;12bytes
        MOVWF   remote_len
        CLRF    remote_len+1
        CALL    remote_read

        MOVLW   0x06
        MOVWF   gcn1				;MACַ6 bytes
        MOVLW   mymac				;mymacĵַ
        MOVWF   FSR
get_mac0:
        MOVLW   0x10
        MOVWF   PORTC
        CALL    assert_rd			;ʼ
        CALL    assert_rd

        MOVF    mdata,W				;MACַPIC
        MOVWF   INDF
        INCF    FSR,F
        DECFSZ  gcn1,F
        GOTO    get_mac0
        RETURN

;-----------------------------------------------------------------------------------
;		MACַ
;-----------------------------------------------------------------------------------
setmac:
; PAGE 1
        CLRF    PORTC
        MOVLW   b'01100010'
        CALL    assert_wr0

        MOVLW   0x01
        MOVWF   PORTC
        MOVLW   mymac
        MOVWF   FSR
        MOVLW   0x06
        MOVWF   gcn1				;MACַĳ6
set_mac0:
        MOVF    INDF,W
        CALL    assert_wr0			;MACַ
        INCF    FSR,F
        INCF    PORTC,F
        DECFSZ  gcn1,F
        GOTO    set_mac0

        MOVLW   0x07
        MOVWF   PORTC
        MOVLW   PAGE_START+1
        CALL    assert_wr0

        MOVLW   0x08
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0
        INCF    PORTC,F
        dw	0x100
        CALL    assert_wr0
        INCF    PORTC,F
        dw	0x100
        CALL    assert_wr0
        INCF    PORTC,F
        dw	0x100
        CALL    assert_wr0
        INCF    PORTC,F
        dw	0x100
        CALL    assert_wr0
        INCF    PORTC,F
        dw	0x100
        CALL    assert_wr0
        INCF    PORTC,F
        dw	0x100
        CALL    assert_wr0
        INCF    PORTC,F
        dw	0x100
        CALL    assert_wr0

        CLRF    PORTC
        MOVLW   0x22
        CALL    assert_wr0
        RETURN

;-----------------------------------------------------------------------------------
;		׼Remote DMAд
;-----------------------------------------------------------------------------------
remote_write:
        MOVLW   0x08
        MOVWF   PORTC
        MOVF    remote_adr,W
        CALL    assert_wr0

        MOVLW   0x09
        MOVWF   PORTC
        MOVF    remote_adr+1,W
        CALL    assert_wr0

        MOVLW   0x0A
        MOVWF   PORTC
        MOVF    remote_len,W
        CALL    assert_wr0

        MOVLW   0x0B
        MOVWF   PORTC
        MOVF    remote_len+1,W
        CALL    assert_wr0

        CLRF    PORTC
        MOVLW   b'00010010'
        CALL    assert_wr0			;Կʼд

        MOVLW   0x10
        MOVWF   PORTC
        RETURN

;-----------------------------------------------------------------------------------
;		׼Remote DMAȡ
;-----------------------------------------------------------------------------------
remote_read:
        MOVLW   0x08
        MOVWF   PORTC
        MOVF    remote_adr,W
        CALL    assert_wr0

        MOVLW   0x09
        MOVWF   PORTC
        MOVF    remote_adr+1,W
        CALL    assert_wr0

        MOVLW   0x0A
        MOVWF   PORTC
        MOVF    remote_len,W
        CALL    assert_wr0

        MOVLW   0x0B
        MOVWF   PORTC
        MOVF    remote_len+1,W
        CALL    assert_wr0

        CLRF    PORTC
        MOVLW   0x0A
        CALL    assert_wr0			;Կʼȡ

        MOVLW   0x10
        MOVWF   PORTC
        RETURN

;-----------------------------------------------------------------------------------
;		Checksum
;-----------------------------------------------------------------------------------
calc_sum:
        BTFSS   bytes,0				;뷽ʽ
        GOTO    calc_sum_high
; Low Byte
        ADDWF   sum,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   sum+1,F
        BTFSC   STATUS,C
        ADDWF   sum,F
        BTFSC   STATUS,C
        ADDWF   sum+1,F
        INCF    bytes,F
        RETURN
; High Byte
calc_sum_high:
        ADDWF   sum+1,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   sum,F
        BTFSC   STATUS,C
        ADDWF   sum+1,F
        INCF    bytes,F
        RETURN

assert_wr2times:
        dw	0x100
        CALL    assert_wr
        dw	0x100
        GOTO    assert_wr

;-----------------------------------------------------------------------------------
;	=mdata
assert_wr2x:
        MOVLW   0x01
        ADDWF   remote_len,F
        BTFSC   STATUS,C
        INCF    remote_len+1,F
        MOVF    mdata,W
        GOTO    assert_wr
;	=W
assert_wr2
        MOVWF   mdata
        MOVLW   0x01
        ADDWF   remote_len,F
        BTFSC   STATUS,C
        INCF    remote_len+1,F
        MOVF    mdata,W

;-----------------------------------------------------------------------------------
;		RTL8019д(Checksum)
;-----------------------------------------------------------------------------------
assert_wr:
        MOVWF   PORTD
assert_wr_2
        BTFSS   bytes,0
        GOTO    assert_wr_high

        ADDWF   sum,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   sum+1,F
        BTFSC   STATUS,C
        ADDWF   sum,F
        BTFSC   STATUS,C
        ADDWF   sum+1,F
        INCF    bytes,F
        GOTO    assert_wr0_2
assert_wr_high:
        ADDWF   sum+1,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   sum,F
        BTFSC   STATUS,C
        ADDWF   sum+1,F
        INCF    bytes,F
        GOTO    assert_wr0_2

;-----------------------------------------------------------------------------------
;		RTL8019д
;-----------------------------------------------------------------------------------
assert_wr0:
        MOVWF   PORTD
assert_wr0_2:
        BSF     STATUS,RP0
        CLRF    TRISD & 0x7F
        BCF     STATUS,RP0

        BCF     WRITE

        BTFSS   RDY
        GOTO    $-1

        BSF     WRITE

        BSF     STATUS,RP0
        MOVLW   0xFF
        MOVWF   TRISD & 0x7F
        BCF     STATUS,RP0
        RETURN

assert_rd:
        BCF     READ

        BTFSS   RDY				;~Wait
        GOTO    $-1

        MOVF    PORTD,W
        MOVWF   mdata

        BSF     READ
        RETURN

;-----------------------------------------------------------------------------------
;		Packetŵش
;-----------------------------------------------------------------------------------
transmit_this_ip:
        MOVLW   this_ip
        MOVWF   FSR
        MOVLW   0x04
transmit_nbytes:
        MOVWF   gcn1
        MOVLW   0x10
        MOVWF   PORTC
transmit0:
        MOVF    INDF,W
        CALL    assert_wr
        INCF    FSR,F
        DECFSZ  gcn1,F
        GOTO    transmit0
        RETURN

transmit_nbytes2:
        MOVWF   gcn1
        MOVLW   0x10
        MOVWF   PORTC
transmit2_0
        MOVF    INDF,W
        CALL    assert_wr2
        INCF    FSR,F
        DECFSZ  gcn1,F
        GOTO    transmit2_0
        RETURN

;-----------------------------------------------------------------------------------
;		Packet
;-----------------------------------------------------------------------------------
transmit:
retry:
        CLRF    PORTC
        CALL    assert_rd

        BTFSC   mdata,2				;bit
        GOTO    transmit			;ȴ

        CLRF    PORTC
        MOVLW   b'00100110'			;bit
        CALL    assert_wr0			;!
trans100:
        MOVLW   0x04
        MOVWF   PORTC
        CALL    assert_rd

        BTFSC   mdata,0
        GOTO    transmit9			;?
        BTFSC   mdata,3
        GOTO    retry

        GOTO    trans100
transmit9:
        RETURN

;-----------------------------------------------------------------------------------
;		׼Ethernet Header
;-----------------------------------------------------------------------------------
prepare_ether2:
        MOVLW   PACKET_SIZE + ARP_SIZE
        MOVWF   remote_len
        GOTO    prepare_ether1
prepare_ether:
        MOVLW   PACKET_SIZE + IP_SIZE
        MOVWF   remote_len
prepare_ether1:
        CLRF    remote_len+1
        CLRF    remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        CALL    remote_write

        MOVLW   0x10				;ݰķͶԷMACַ
        MOVWF   PORTC
        MOVLW   eth_src
        MOVWF   FSR
        MOVLW   0x06
        CALL    transmit_nbytes

        MOVLW   mymac				;ԼIPַ
        MOVWF   FSR
        MOVLW   0x06
        CALL    transmit_nbytes
        RETURN

;-----------------------------------------------------------------------------------
;		׼IP Header
;-----------------------------------------------------------------------------------
prepare_ip:
        CALL    prepare_ether
        MOVLW   COM_PROTO
        CALL    assert_wr
        MOVLW   IP_PROTO
        CALL    assert_wr

        CALL    ip_common

        MOVLW   ip_sum - ip_header + PACKET_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
set_checksum:
        COMF    sum,F
        COMF    sum+1,F

        MOVLW   0x02
        MOVWF   remote_len			;Checksum 2 bytes
        CLRF    remote_len+1
        CALL    remote_write

        MOVLW   0x10
        MOVWF   PORTC
        MOVF    sum+1,W
        CALL    assert_wr0			;дChecksum(assert_wr0)
        MOVF    sum,W
        CALL    assert_wr0
        RETURN

;-----------------------------------------------------------------------------------
;		IP Protocol Header
;-----------------------------------------------------------------------------------
ip_common:
        CALL    clear_sum			;Checksumֵ

        MOVLW   0x10
        MOVWF   PORTC
        MOVLW   0x45				;ID
        CALL    assert_wr
        MOVLW   0x00				;TOS
        CALL    assert_wr

        MOVF    ip_length,W			;length high
        CALL    assert_wr
        MOVF    ip_length+1,W			;length low
        CALL    assert_wr

        MOVLW   ident
        MOVWF   FSR
        MOVF    INDF,W				;Seq No High
        CALL    assert_wr
        INCF    FSR,F

        MOVF    INDF,W				;Seq No Low
        CALL    assert_wr
        MOVLW   0x01
        ADDWF   INDF,F
        DECF    FSR,F
        BTFSC   STATUS,C
        ADDWF   INDF,F

        MOVLW   0x00				;flagment(2bytes)
        CALL    assert_wr
        MOVLW   0x00
        CALL    assert_wr

        MOVLW   0xFF				;TTL
        CALL    assert_wr

        MOVF    proto,W				;PROTOCOL = anything
        CALL    assert_wr

        CALL    assert_wr2times			;Sum is Zero

        CALL    transmit_this_ip

        MOVLW   ip_src				;to ip
        MOVWF   FSR
        MOVLW   0x04
        CALL    transmit_nbytes
        RETURN

;-----------------------------------------------------------------------------------
;		Parallel I/F
;-----------------------------------------------------------------------------------
        ORG     0x0820
udp_parallel:
        MOVLW   HIGH $
        MOVWF   PCLATH
        MOVLW   udp_data
        MOVWF   FSR

        MOVLW   0x06
        SUBWF   INDF,W
        BTFSC   STATUS,C
        GOTO    main90 & 0x7ff
        MOVF    INDF,W
        INCF    FSR,F
        ADDWF   PCL,F
        GOTO    para_get_status			;ȡStatus
        GOTO    para_set_high			;High趨
        GOTO    para_set_low			;Low趨
        GOTO    para_set_whole			;ȫ趨
        GOTO    para_get_adc			;A/D任
        GOTO    para_set_rbpu			;ڲPull-Up趨
;
;	ΪHIGH/INPUT
para_set_high
        CALL    para_set_common
        MOVF    wk+1,W
        IORWF   INDF,F
        GOTO    para_get_status

;
;	ΪLOW/OUTPUT
para_set_low
        CALL    para_set_common
        COMF    wk+1,F
        MOVF    wk+1,W
        ANDWF   INDF,F
        GOTO    para_get_status
;
;	bitλ
para_set_common
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   wk				;Bitλ(0-7)
        MOVLW   0x01
        MOVWF   wk+1
para_set_common0
        MOVLW   0x00
        SUBWF   wk,W
        BTFSC   STATUS,Z
        GOTO    para_set_common9
        BCF     STATUS,C
        RLF     wk+1,F
        DECF    wk,F
        GOTO    para_set_common0
para_set_common9
        DECF    FSR,F
        MOVF    INDF,W				;I/O Port
        MOVWF   FSR
        RETURN

;
;	SET WHOLE Mode
para_set_whole
        MOVF    INDF,W
        MOVWF   ptr				;Port
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   gcn1				;Size
        INCF    FSR,F
para_set_whole0
        MOVF    INDF,W
        MOVWF   wk				;Mask
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   wk+1				;Value
        INCF    FSR,F

        MOVF    FSR,W
        MOVWF   wk+2				;save FSR
        MOVF    ptr,W
        MOVWF   FSR
        MOVF    INDF,W
        ANDWF   wk,W
        IORWF   wk+1,W
        MOVWF   INDF				; *ptr = (*ptr & Mask) | Value
        MOVF    wk+2,W
        MOVWF   FSR				;Restore FSR

        INCF    ptr,F
        DECFSZ  gcn1,F
        GOTO    para_set_whole0
        GOTO    para_get_status

;
; ڲPull up On/Off
para_set_rbpu
        BSF     STATUS,RP0
        MOVLW   0x00
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    para_set_rbpu1
        BSF     OPTION_REG,NOT_RBPU
        GOTO    para_set_rbpu9
para_set_rbpu1
        BCF     OPTION_REG,NOT_RBPU
para_set_rbpu9
        BCF     STATUS,RP0
        GOTO    para_get_status

;-----------------------------------------------------------------------------------
para_get_adc
        MOVF    INDF,W
        MOVWF   ADCON1				;ADCON1趨
        BSF     ADCON1,0
        INCF    FSR,F

        MOVF    INDF,W
        MOVWF   wait_cn
para_get_aqu0
        MOVLW   0x08
        MOVWF   wait_cn2
        DECFSZ  wait_cn2,F
        GOTO    $-1
        DECFSZ  wait_cn,F
        GOTO    para_get_aqu0			;25us X WaitTime

        BSF     ADCON1,2			;ʼA/D任
        BTFSC   ADCON1,2			;ȴA/D任
        GOTO    $-1

        CLRF    PCLATH
para_get_status
        MOVLW   para_port			;ԪPort
        MOVWF   wk+2
common_get_status:
        CLRF    ip_length
        MOVLW   IP_SIZE + UDP_SIZE + PARALLEL_PACKET_SIZE
        MOVWF   ip_length+1

        CLRF    PCLATH

        MOVLW   UDP_PROTO			;UDP Packet
        MOVWF   proto
        CALL    prepare_ip

        CALL    clear_sum

        MOVLW   PACKET_SIZE+IP_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        MOVLW   UDP_SIZE + PARALLEL_PACKET_SIZE
        MOVWF   remote_len
        MOVLW   HIGH (UDP_SIZE + PARALLEL_PACKET_SIZE)
        MOVWF   remote_len+1
        CALL    remote_write

        MOVLW   0x10
        MOVWF   PORTC

        MOVF    wk+2,W				;para_port
        MOVWF   FSR

        MOVF    INDF,W				;From Port(HIGH)
        CALL    assert_wr
        INCF    FSR,F
        MOVF    INDF,W				;From Port(LOW)
        CALL    assert_wr

        MOVF    udp_src_port,W			;To Port
        CALL    assert_wr
        MOVF    udp_src_port+1,W
        CALL    assert_wr

        MOVLW   HIGH (UDP_SIZE + PARALLEL_PACKET_SIZE)
        CALL    assert_wr
        MOVLW   (UDP_SIZE + PARALLEL_PACKET_SIZE)	;UDP DATAGRAM SIZE
        CALL    assert_wr

        CALL    assert_wr2times			;sum(not fixed)
;
;		DGRAM
;
;		clr	pclath
        MOVF    PORTA,W
        CALL    assert_wr
        MOVF    PORTB,W
        CALL    assert_wr

        MOVLW   0x85
        MOVWF   FSR
        MOVF    INDF,W
        CALL    assert_wr
        INCF    FSR,F
        MOVF    INDF,W
        CALL    assert_wr

        MOVF    ADRESH,W
        MOVWF   val+1
        BSF     STATUS,RP0
        MOVF    ADRESL & 0x7F,W
        BCF     STATUS,RP0
        MOVWF   val

        MOVF    val+1,W
        CALL    assert_wr			;AD任(H)
        MOVF    val,W
        CALL    assert_wr			;AD任(L)

        BSF     STATUS,RP0
        MOVF    ADCON1 & 0x7F,W
        BCF     STATUS,RP0
        CALL    assert_wr
        MOVLW   0x00
        CALL    assert_wr

        MOVLW   HIGH calc_udp_sum
        MOVWF   PCLATH
        CALL    calc_udp_sum & 0x7ff
        MOVLW   HIGH transmit_60bytes
        MOVWF   PCLATH
        CALL    transmit_60bytes & 0x7ff
main90:
        MOVLW   HIGH main9
        MOVWF   PCLATH
        GOTO    main9

;-----------------------------------------------------------------------------------
;		UDP Checksum
;
calc_udp_sum:
        CLRF    PCLATH
        CLRF    bytes				;2 byte
        MOVLW   this_ip				;ԼIPַ
        MOVWF   FSR
        MOVF    INDF,W
        CALL    calc_sum
        INCF    FSR,F
        MOVF    INDF,W
        CALL    calc_sum
        INCF    FSR,F
        MOVF    INDF,W
        CALL    calc_sum
        INCF    FSR,F
        MOVF    INDF,W
        CALL    calc_sum

        MOVF    ip_src,W			;ԷIPַ
        CALL    calc_sum
        MOVF    ip_src+1,W
        CALL    calc_sum
        MOVF    ip_src+2,W
        CALL    calc_sum
        MOVF    ip_src+3,W
        CALL    calc_sum

        dw	0x100					;Protocol
        CALL    calc_sum
        MOVLW   UDP_PROTO
        CALL    calc_sum

        MOVF    remote_len+1,W			;#PARALLEL_PACKET_SIZE>>8
        CALL    calc_sum
        MOVF    remote_len,W			;#PARALLEL_PACKET_SIZE & 0ffh
        CALL    calc_sum

        MOVLW   PACKET_SIZE + IP_SIZE + 6
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        CALL    set_checksum
        RETURN

transmit_60bytes:
        CLRF    PCLATH
        MOVLW   0x04
        MOVWF   PORTC
        MOVLW   PAGE_BEGIN			;transmit page is start page
        CALL    assert_wr0

        MOVLW   0x05
        MOVWF   PORTC
        MOVLW   0x3C				;ǣ bytes.(PARALLEL_PACKET_SIZE+IP_SIZE+PACKET_SIZE) & 0ffh
        CALL    assert_wr0

        MOVLW   0x06
        MOVWF   PORTC
        MOVLW   0x00				; (PARALLEL_PACKET_SIZE+IP_SIZE+PACKET_SIZE) >> 8
        CALL    assert_wr0

        CALL    transmit
        RETURN

;-----------------------------------------------------------------------------------
;		Serial Port
;
udp_serial:
        BSF     STATUS,RP0
        BSF     STATUS,RP1
        MOVLW   0x10
        MOVWF   transmitted
        CLRF    STATUS

        MOVF    udp_length,W
        MOVWF   remote_len+1
        MOVF    udp_length+1,W
        MOVWF   remote_len
        MOVLW   0x08
        SUBWF   remote_len,F
        BTFSS   STATUS,C
        DECF    remote_len+1,F

        MOVLW   HIGH get_dgram
        MOVWF   PCLATH
        CALL    get_dgram
        MOVLW   HIGH $
        MOVWF   PCLATH

        BTFSC   STATUS,C
        GOTO    main90 & 0x7ff

        MOVF    mdata,W
        MOVWF   udp_data
        MOVLW   0x04
        SUBWF   mdata,W
        BTFSC   STATUS,C
        GOTO    main90 & 0x7ff
        MOVF    mdata,W
        ADDWF   PCL,F
        GOTO    ser_get_status			;ʾ״̬
        GOTO    ser_register_tag		;ַǼ
        GOTO    ser_unregister_tag		;ַɾ
        GOTO    ser_transmit			;
;
;		ARPӦմ
ser_arp:
        BCF     STATUS,IRP
        MOVLW   arp_src_mac
        MOVWF   FSR
        BSF     STATUS,RP0
        BSF     STATUS,RP1
        MOVF    INDF,W
        MOVWF   on_ether
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   on_ether+1
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   on_ether+2
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   on_ether+3
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   on_ether+4
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   on_ether+5
        CLRF    STATUS
        BSF     RCSTA,CREN
        BSF     INTCON,PEIE
        MOVLW   HIGH main9
        MOVWF   PCLATH
        GOTO    main9

;-----------------------------------------------------------------------------------
;		HostĴڷ״̬
;-----------------------------------------------------------------------------------
ser_get_status
        CLRF    ip_length
        MOVLW   IP_SIZE + UDP_SIZE + SERIAL_PACKET_SIZE
        MOVWF   ip_length+1

        CLRF    PCLATH

        MOVLW   UDP_PROTO
        MOVWF   proto
        CALL    prepare_ip

        CALL    clear_sum

        MOVLW   PACKET_SIZE+IP_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        MOVLW   (UDP_SIZE + SERIAL_PACKET_SIZE) & 0xff
        MOVWF   remote_len
        MOVLW   HIGH (UDP_SIZE + SERIAL_PACKET_SIZE)
        MOVWF   remote_len+1
        CALL    remote_write

        MOVLW   0x10
        MOVWF   PORTC

        MOVLW   serial_port
        MOVWF   FSR
        MOVF    INDF,W
        CALL    assert_wr
        INCF    FSR,F
        MOVF    INDF,W
        CALL    assert_wr

        MOVF    udp_src_port,W
        CALL    assert_wr
        MOVF    udp_src_port+1,W
        CALL    assert_wr

        MOVLW   HIGH (UDP_SIZE + SERIAL_PACKET_SIZE)
        CALL    assert_wr
        MOVLW   (UDP_SIZE + SERIAL_PACKET_SIZE) & 0xff		;UDP DATAGRAM SIZE
        CALL    assert_wr

        CALL    assert_wr2times
;
;		DGRAM
;
        CLRF    PCLATH

        MOVF    udp_data,W
        CALL    assert_wr

        BSF     STATUS,IRP
        MOVLW   transmitted & 0xff
        MOVWF   FSR
        MOVF    INDF,W
        CALL    assert_wr

        MOVLW   on_ether
        MOVWF   FSR
        MOVLW   SERIAL_PACKET_SIZE-2
        CALL    transmit_nbytes
        BCF     STATUS,IRP

        MOVLW   HIGH calc_udp_sum
        MOVWF   PCLATH
        CALL    calc_udp_sum
        MOVLW   HIGH transmit_60bytes
        MOVWF   PCLATH
        CALL    transmit_60bytes
        MOVLW   HIGH main9
        MOVWF   PCLATH
        GOTO    main9

;-----------------------------------------------------------------------------------
;		232C
ser_transmit
        BSF     STATUS,RP0
        BSF     STATUS,RP1
        CLRF    transmitted
        CLRF    STATUS
ser_transmit0
        MOVLW   HIGH get_dgram
        MOVWF   PCLATH
        CALL    get_dgram
        MOVLW   HIGH $
        MOVWF   PCLATH
        BTFSC   STATUS,C
        GOTO    ser_transmit9			;EOT

        BSF     STATUS,RP0
        BSF     STATUS,RP1
        BTFSS   on_flow,0
        GOTO    ser_transmit1

        CLRF    STATUS
        BTFSC   PORTB,RB0
        GOTO    ser_transmit9
ser_transmit1
        CLRF    STATUS
        CALL    async_transmit
        BSF     STATUS,RP0
        BSF     STATUS,RP1

        INCF    transmitted,F
        CLRF    STATUS
        GOTO    ser_transmit0
ser_transmit9
        MOVLW   HIGH ser_get_status
        MOVWF   PCLATH
        GOTO    ser_get_status

;-----------------------------------------------------------------------------------
ser_register_tag
        MOVLW   0x06
        MOVWF   gcn1
        MOVLW   udp_data+1
        MOVWF   FSR
        MOVLW   HIGH copy_toram
        MOVWF   PCLATH
        CALL    copy_toram

        MOVLW   HIGH ser_register
        MOVWF   PCLATH
        GOTO    ser_register

;-----------------------------------------------------------------------------------
ser_unregister_tag
        MOVLW   HIGH ser_unregister
        MOVWF   PCLATH
        GOTO    ser_unregister

;-----------------------------------------------------------------------------------
;		յPacketǷSocket
;-----------------------------------------------------------------------------------
search_socket:
        BSF     STATUS,IRP
        MOVLW   SOCKETS
        MOVWF   com_cn
        MOVLW   skb
        MOVWF   com_fsr
search_socket0:
        MOVF    com_fsr,W
        MOVWF   FSR
        BTFSS   INDF,7
        GOTO    search_socket9 & 0x7ff

        MOVLW   0x02
        ADDWF   FSR,F
        MOVF    ip_src,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    search_socket9 & 0x7ff
        INCF    FSR,F
        MOVF    ip_src+1,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    search_socket9 & 0x7ff
        INCF    FSR,F
        MOVF    ip_src+2,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    search_socket9 & 0x7ff
        INCF    FSR,F
        MOVF    ip_src+3,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    search_socket9 & 0x7ff
        INCF    FSR,F

        MOVF    tcp_src_port,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    search_socket9 & 0x7ff
        INCF    FSR,F
        MOVF    tcp_src_port+1,W
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        GOTO    search_socket9 & 0x7ff
        INCF    FSR,F

        MOVLW   0x07
        SUBWF   FSR,F
        MOVLW   0xF0
        IORWF   INDF,F
        DECF    FSR,F
        BSF     STATUS,C
        RETURN
search_socket9:
        MOVLW   0x10
        ADDWF   com_fsr,F
        DECFSZ  com_cn,F
        GOTO    search_socket0 & 0x7ff
        BCF     STATUS,IRP
        BCF     STATUS,C
        RETURN

;-----------------------------------------------------------------------------------
;		Socket
;-----------------------------------------------------------------------------------
socket_entry:
        BSF     STATUS,IRP
        MOVLW   skb
        MOVWF   FSR
        MOVF    FSR,W
        MOVWF   com_fsr
        MOVLW   SOCKETS
        MOVWF   com_cn
entry0:
        BTFSC   INDF,7
        GOTO    entry9 & 0x7ff

        MOVLW   SYN_RCVD
        MOVWF   INDF
        INCF    FSR,F
        MOVLW   0xF0
        MOVWF   INDF
        INCF    FSR,F
        MOVF    ip_src,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    ip_src+1,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    ip_src+2,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    ip_src+3,W
        MOVWF   INDF
        INCF    FSR,F

        MOVF    tcp_src_port,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_src_port+1,W
        MOVWF   INDF
        INCF    FSR,F

        MOVF    tcp_seq_no,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_seq_no+1,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_seq_no+2,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_seq_no+3,W
        MOVWF   INDF
        INCF    FSR,F

        MOVF    tcp_ack_no,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_ack_no+1,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_ack_no+2,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    tcp_ack_no+3,W
        MOVWF   INDF
        INCF    FSR,F
        BCF     STATUS,IRP
        BCF     STATUS,C
        RETURN
entry9:
        MOVLW   0x10
        ADDWF   FSR,F
        MOVLW   0x10
        ADDWF   com_fsr,F
        DECFSZ  com_cn,F
        GOTO    entry0 & 0x7ff
socket_entry_99
        BCF     STATUS,IRP
        BSF     STATUS,C
        RETURN

;-----------------------------------------------------------------------------------
;		Ethernet PacketĹ㲥
;-----------------------------------------------------------------------------------
broad_cast:
        CLRF    PCLATH

        MOVLW   0x00
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        MOVLW   IP_SIZE+PACKET_SIZE
        MOVWF   remote_len
        MOVLW   0x00
        MOVWF   remote_len+1
        CALL    remote_write

        MOVLW   0x10				;ff-ff-ff-ff-ff-ff
        MOVWF   PORTC
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr

        MOVLW   mymac				;ԼMACַ
        MOVWF   FSR
        MOVLW   0x06
        CALL    transmit_nbytes
        RETURN

bootp2:
        CALL    broad_cast & 0x7ff
        CLRF    PCLATH

        MOVLW   COM_PROTO
        CALL    assert_wr
        MOVLW   IP_PROTO
        CALL    assert_wr

        MOVLW   0xFF
        MOVWF   ip_src				;ԼIPַΪ:255.255.255.255
        MOVWF   ip_src+1
        MOVWF   ip_src+2
        MOVWF   ip_src+3

        MOVLW   HIGH (DHCP_SIZE+20)
        MOVWF   ip_length
        MOVLW   LOW (DHCP_SIZE+20)
        MOVWF   ip_length+1

        MOVLW   UDP_PROTO
        MOVWF   proto
        CALL    ip_common

        MOVLW   ip_sum - ip_header + PACKET_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        GOTO    set_checksum

bootp:
        CALL    bootp2 & 0x7ff
        CLRF    PCLATH

        CALL    clear_sum

        MOVLW   PACKET_SIZE+IP_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        MOVLW   LOW DHCP_SIZE
        MOVWF   remote_len
        MOVLW   HIGH DHCP_SIZE
        MOVWF   remote_len+1
        CALL    remote_write

        MOVLW   0x10
        MOVWF   PORTC

        MOVLW   0x00				;Client BOOTP Port
        CALL    assert_wr
        MOVLW   BOOTPC_PORT			;Client BOOTP Port
        CALL    assert_wr

        MOVLW   0x00				;Server BOOTP Port
        CALL    assert_wr
        MOVLW   BOOTPS_PORT			;Server BOOTP Port
        CALL    assert_wr

        MOVLW   HIGH DHCP_SIZE
        CALL    assert_wr
        MOVLW   LOW DHCP_SIZE			;length
        CALL    assert_wr

        CALL    assert_wr2times			;sum

        MOVLW   0x01
        CALL    assert_wr			; Requare:1,Reply:2
        MOVLW   0x01
        CALL    assert_wr			; 10Mbps Ethernet:1
        MOVLW   0x06
        CALL    assert_wr			; EthernetLength:6
        dw	0x100
        CALL    assert_wr			; Hop Count

        MOVLW   mymac+2
        MOVWF   FSR
        MOVF    INDF,W
        CALL    assert_wr
        INCF    FSR,F
        MOVF    INDF,W
        CALL    assert_wr
        INCF    FSR,F
        MOVF    INDF,W
        CALL    assert_wr
        INCF    FSR,F
        MOVF    INDF,W
        CALL    assert_wr

        CALL    assert_wr2times
        CALL    assert_wr2times

        MOVLW   0x10
        MOVWF   gcn1
bootp_10:
        MOVLW   HIGH assert_wr
        MOVWF   PCLATH
        dw	0x100
        CALL    assert_wr
        MOVLW   HIGH $
        MOVWF   PCLATH
        DECFSZ  gcn1,F
        GOTO    bootp_10 & 0x7ff
;
; Client Hardware Address
;
        MOVLW   mymac
        MOVWF   FSR
        MOVLW   HIGH transmit_nbytes
        MOVWF   PCLATH
        MOVLW   0x06
        CALL    transmit_nbytes
        MOVLW   HIGH $
        MOVWF   PCLATH
        MOVLW   0x0A
        MOVWF   gcn1
bootp_10_0:
        MOVLW   HIGH assert_wr
        MOVWF   PCLATH
        dw	0x100
        CALL    assert_wr
        MOVLW   HIGH $
        MOVWF   PCLATH
        DECFSZ  gcn1,F
        GOTO    bootp_10_0 & 0x7ff
;
; ļ
;
        MOVLW   0xC0
        MOVWF   gcn1
bootp_20:
        MOVLW   HIGH assert_wr
        MOVWF   PCLATH
        dw	0x100
        CALL    assert_wr
        MOVLW   HIGH $
        MOVWF   PCLATH
        DECFSZ  gcn1,F
        GOTO    bootp_20 & 0x7ff
;
; Magic
;
        MOVLW   HIGH assert_wr
        MOVWF   PCLATH
        MOVLW   0x63
        CALL    assert_wr
        MOVLW   0x82
        CALL    assert_wr
        MOVLW   0x53
        CALL    assert_wr
        MOVLW   0x63
        CALL    assert_wr
        RETURN

bootp_tx:
        CLRF    PCLATH
        dw	0x100
        CALL    calc_sum
        dw	0x100
        CALL    calc_sum
        dw	0x100
        CALL    calc_sum
        dw	0x100
        CALL    calc_sum

        MOVLW   0xFF
        CALL    calc_sum
        MOVLW   0xFF
        CALL    calc_sum
        MOVLW   0xFF
        CALL    calc_sum
        MOVLW   0xFF
        CALL    calc_sum

        dw	0x100
        CALL    calc_sum
        MOVLW   0x11
        CALL    calc_sum

        MOVLW   HIGH DHCP_SIZE
        CALL    calc_sum
        MOVLW   LOW DHCP_SIZE
        CALL    calc_sum

        MOVLW   PACKET_SIZE + IP_SIZE + 6
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1
        CALL    set_checksum

        MOVLW   0x04
        MOVWF   PORTC
        MOVLW   PAGE_BEGIN
        CALL    assert_wr0

        MOVLW   0x05
        MOVWF   PORTC
        MOVLW   LOW (DHCP_SIZE+IP_SIZE+PACKET_SIZE)
        CALL    assert_wr0

        MOVLW   0x06
        MOVWF   PORTC
        MOVLW   HIGH (DHCP_SIZE+IP_SIZE+PACKET_SIZE)
        CALL    assert_wr0

        CALL    transmit
        RETURN

;-----------------------------------------------------------------------------------
;		дEEPROM
;		ַԶ
;-----------------------------------------------------------------------------------
        GOTO    $
write_eeprom16
        MOVLW   'b'
        MOVWF   ind
        MOVF    wk+2,W
        XORWF   wk+1,F
        MOVF    wk+1,W
        XORWF   wk+2,F
        MOVF    wk+2,W
        XORWF   wk+1,F
        CALL    write_eeprom
        MOVF    wk+2,W
        MOVWF   wk+1
write_eeprom
        MOVLW   'w'
        SUBWF   ind,W
        BTFSC   STATUS,Z
        GOTO    write_eeprom16
write_eeprom0
        BSF     STATUS,RP1
        BCF     STATUS,RP0
        MOVF    wk,W
        MOVWF   EEADR
        MOVF    wk+1,W
        MOVWF   EEDATA
        BSF     STATUS,RP0
        BCF     EECON1,EEPGD
        BSF     EECON1,WREN

        BCF     INTCON,GIE
        MOVLW   0x55
        MOVWF   EECON2
        MOVLW   0xAA
        MOVWF   EECON2
        BSF	EECON1,WR

	BTFSC	EECON1,WR
        GOTO    $-1

        BCF     EECON1,WREN
        BCF     STATUS,RP0
        BCF     STATUS,RP1
        INCF    wk,F

        BSF     INTCON,GIE
        RETURN

get_nextbyte
        MOVF    remote_len,W
        IORWF   remote_len+1,W
        BTFSC   STATUS,Z
        GOTO    get_nextbyte9

        BCF     READ
        BTFSS   RDY				;~Wait
        GOTO    $-1
        MOVF    PORTD,W
        BSF     READ

        MOVWF   mdata
        MOVLW   0x0A
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    get_nextbyte9

        MOVLW   0x01				;Length--
        SUBWF   remote_len,F
        BTFSS   STATUS,C
        SUBWF   remote_len+1,F
        RETURN
get_nextbyte9
        CLRF    mdata
        RETURN


;-----------------------------------------------------------------------------------
;		CGIĽ(GET)
;		00b=192.168.0.200
;-----------------------------------------------------------------------------------
parse_cgi
        CALL    get_nextbyte
        MOVLW   0x00
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse9_tag
        MOVLW   0x0A
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse9_tag
        MOVLW   'I'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    initial_values_tag		;Initialize Value
        MOVLW   'R'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    modify_pin			;Pin

        MOVLW   '0'
        SUBWF   mdata,F
        MOVF    mdata,W
        MOVWF   wk
        SWAPF   wk,F

        CALL    get_nextbyte
        MOVLW   0x00
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse9_tag

        MOVLW   '0'
        SUBWF   mdata,F
        MOVF    mdata,W
        IORWF   wk,F

        CALL    get_nextbyte
        MOVLW   0x00
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse9_tag
        MOVF    mdata,W
        MOVWF   ind
        MOVLW   'b'
        SUBWF   ind,W
        BTFSC   STATUS,Z
        GOTO    parse4
        MOVLW   'w'
        SUBWF   ind,W
        BTFSC   STATUS,Z
        GOTO    parse4
        GOTO    parse9_tag
parse4
        CLRF    wk+1
        CLRF    wk+2

        CALL    get_nextbyte
        MOVLW   0x00
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse9_tag
        MOVLW   '&'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse_cgi
parse_cgi0
        CALL    get_nextbyte
        MOVLW   0x00
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse9_tag
        MOVLW   ' '
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse91_tag
        MOVLW   0x09
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse91_tag
        MOVLW   '&'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse_cgi2

        MOVLW   '.'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse_cgi3
        MOVLW   ','
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    parse_cgi3
        MOVLW   '0'
        SUBWF   mdata,W
        BTFSS   STATUS,C
        GOTO    parse_cgi3
        MOVLW   0xC6
        ADDWF   mdata,W
        BTFSC   STATUS,C
        GOTO    parse_cgi3

        CALL    multiply_added
        GOTO    parse_cgi0
parse_cgi2
        CALL    write_eeprom
        GOTO    parse_cgi
parse_cgi3
        CALL    write_eeprom
        CLRF    wk+1
        CLRF    wk+2
        GOTO    parse_cgi0
parse91_tag
        CALL    write_eeprom
parse9_tag
        MOVLW   HIGH parse9
        MOVWF   PCLATH
        GOTO    parse9

;-----------------------------------------------------------------------------------
;		data x 10
;-----------------------------------------------------------------------------------
multiply_added
        MOVLW   '0'
        SUBWF   mdata,F

        BCF     STATUS,C
        RLF     wk+1,F
        RLF     wk+2,F

        MOVF    wk+1,W
        MOVWF   mul10
        MOVF    wk+2,W
        MOVWF   mul10+1

        BCF     STATUS,C
        RLF     wk+1,F
        RLF     wk+2,F
        BCF     STATUS,C
        RLF     wk+1,F
        RLF     wk+2,F
        MOVF    mul10,W
        ADDWF   wk+1,F
        BTFSC   STATUS,C
        INCF    wk+2,F
        MOVF    mul10+1,W
        ADDWF   wk+2,F

        MOVF    mdata,W
        ADDWF   wk+1,F
        BTFSC   STATUS,C
        INCF    wk+2,F
        RETURN

;-----------------------------------------------------------------------------------
;		EEPROMݻָΪֵ
;-----------------------------------------------------------------------------------
        GOTO    $
initial_values_tag
        CALL    initial_values
        GOTO    parse9_tag

initial_values
        MOVLW   default_values_end - default_values_begin
        MOVWF   gcn1
        CLRF    wk
initial_values0
        CALL    get_initial_value
        MOVWF   wk+1

        MOVLW   HIGH write_eeprom0
        MOVWF   PCLATH
        CALL    write_eeprom0
        MOVLW   HIGH $
        MOVWF   PCLATH

        DECFSZ  gcn1,F
        GOTO    initial_values0
        RETURN

;-----------------------------------------------------------------------------------
;		CGIŵĶ
;		RA0=H
;-----------------------------------------------------------------------------------
modify_pin
        CALL    get_nextbyte
        MOVLW   'A'
        SUBWF   mdata,W
        BTFSS   STATUS,C
        GOTO    parse9_tag
        MOVLW   0xBD				;'B'
        ADDWF   mdata,W
        BTFSC   STATUS,C
        GOTO    parse9_tag
        MOVLW   'A'
        SUBWF   mdata,F
        MOVLW   PORTA
        ADDWF   mdata,F
        MOVF    mdata,W
        MOVWF   FSR

        CALL    get_nextbyte
        MOVLW   '0'
        SUBWF   mdata,W
        BTFSS   STATUS,C
        GOTO    parse9_tag
        MOVLW   0xC6
        ADDWF   mdata,W
        BTFSC   STATUS,C
        GOTO    parse9_tag
        MOVLW   '0'
        SUBWF   mdata,F
        INCF    mdata,F
        CLRF    wk
        BSF     STATUS,C
modify_pin0
        RLF     wk,F
        DECFSZ  mdata,F
        GOTO    modify_pin0

        CALL    get_nextbyte
        MOVLW   '='
        SUBWF   mdata,W
        BTFSS   STATUS,Z			;'='Ļ
        GOTO    parse9_tag

        CALL    get_nextbyte
        MOVLW   'H'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    modify_pin_h

        COMF    wk,F
        MOVF    wk,W				;'L'I/O˿
        ANDWF   INDF,F
        GOTO    parse9_tag
modify_pin_h
        MOVF    wk,W				;'H'I/O˿
        IORWF   INDF,F
        GOTO    parse9_tag
get_initial_value
        MOVLW   0x1F				;ûñ?
        MOVWF   PCLATH				;ȡóֵ
        MOVF    wk,W
        MOVWF   PCL

;===================================================================================
;		ʼ
;===================================================================================
Start:
        CLRF    PORTA				;ʼ˿
        CLRF    PORTB
        CLRF    PORTC				;PORTC=RTL8019ASSA0-SA5
        CLRF    PORTD
        MOVLW   b'111'
        MOVWF   PORTE				;߶Ϊ

        BSF     STATUS,RP0
        MOVLW   b'10000110'
        OPTION
        ;MOVWF	OPTION_REG			;ж
        MOVLW   b'10000010'
        MOVWF   ADCON1 & 0x7F			;RE0-2 are Digital Pin
        MOVLW   b'00111111'
        MOVWF   TRISA & 0x7F			;RA0-4ΪAD
        MOVLW   0x00
        MOVWF   TRISE & 0x7F			;RE0-2Ϊ
        BCF     STATUS,RP0

        CLRF    use				;LCD/ЧFlag

        CALL    get_ip_address & 0x7ff
        CALL    get_port_no & 0x7ff
;
;	LCD Port
;	0Ļ,rb7-2Ϊ
;
        BSF     STATUS,RP0
        MOVF    lcd_port & 0x7F,W
        IORWF   lcd_port+1,W			;LCD PortǷΪ0
        MOVLW   b'00001111'			;LCD PortΪ0,RB7-4Ϊ,RB3-0Ϊ
        BTFSS   STATUS,Z
        MOVLW   b'00000011'			;LCD PortΪ0,RB7-2Ϊ,RB1-0Ϊ
        MOVWF   TRISB & 0x7F
        BCF     STATUS,RP0

        BTFSS   STATUS,Z
        BSF     use,0				;LCD PortΪ0,use.LCD

; 鴮
        CALL    clear_seq_no & 0x7ff		;TCP

        CALL    init_lcd & 0x7ff		;ʼLCDģ

        MOVLW   0x03
        MOVWF   PORTE

        MOVLW   0x05
        MOVWF   wait_cn				;ȴ5ms
        CALL    wait_ms & 0x7ff

        BSF     STATUS,RP0
        MOVLW   0xE0
        MOVWF   TRISC & 0x7F
        MOVLW   0xFF
        MOVWF   TRISD & 0x7F
        MOVLW   0x00
        MOVWF   TRISE & 0x7F
        BCF     STATUS,RP0

        CALL    init_socket & 0x7ff		;ʼSocket Buffer
        CLRF    PCLATH

        CALL    initialize			;ʼRTL8019AS

        MOVLW   HIGH $
        MOVWF   PCLATH

        MOVLW   this_ip				;ԼIPַǷΪ:0.0.0.0?
        MOVWF   FSR
        MOVF    INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        INCF    FSR,F
        IORWF   INDF,W
        BTFSC   STATUS,Z
        GOTO    start1 & 0x7ff			;ԼIPַΪ0.0.0.0,start1ִ

        MOVLW   HIGH print_ip			;LCDʾԼIPַ
        MOVWF   PCLATH
        CALL    print_ip & 0x7ff
        GOTO    start2 & 0x7ff
start1:
        MOVLW   HIGH write_lcd4
        MOVWF   PCLATH
        BSF     PORTB,RB2
        MOVLW   'D'				;LCDʾ'DHCP'
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff
        MOVLW   'H'
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff
        MOVLW   'C'
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff
        MOVLW   'P'
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff
        MOVLW   HIGH $
        MOVWF   PCLATH
start2:
        BSF     STATUS,RP0
        MOVLW   b'11110000'
        MOVWF   TRISC & 0x7F			;RC.4Ϊ
        BCF     STATUS,RP0

        MOVLW   HIGH wait_us
        MOVWF   PCLATH
        MOVLW   0x64
        MOVWF   wait_cn				;ȴ100us
        CALL    wait_us & 0x7ff

        MOVLW   HIGH $
        MOVWF   PCLATH
        BTFSS   PORTC,RC4			;RC4
        GOTO    bootstrap & 0x7ff		;RC4=0,Bootstrap״̬

        BSF     STATUS,RP0
        MOVLW   b'10100000'
        MOVWF   TRISC & 0x7F			;ָPORTC״̬
        MOVLW   b'00100110'			;ʼ첽ͨģ
        MOVWF   TXSTA & 0x7F
        MOVLW   BAUD_RATE
        MOVWF   SPBRG & 0x7F			;ôڲ
        BSF     PIE1 & 0x7F,RCIE		;ж
        BCF     STATUS,RP0
        MOVLW   b'10000000'			;ʼ첽ͨģ
        MOVWF   RCSTA
        BCF     STATUS,RP0
        BCF     INTCON,PEIE			;жʹ

        CLRF    PCLATH

        MOVLW   LOW assert_wr2x
        MOVWF   dest
        MOVLW   HIGH assert_wr2x
        MOVWF   dest+1
        BSF     STATUS,RP0
        CLRF    dhcp_done & 0x7F
        BCF     STATUS,RP0

        CLRF    PORTB				;״̬:RB=0
        CLRF    TMR1L
        CLRF    TMR1H
        MOVLW   0x05
        MOVWF   T1CON
        BSF     STATUS,RP0
        BSF     PIE1 & 0x7F,TMR1IE
        BCF     STATUS,RP0
        BSF     INTCON,PEIE
        BSF     INTCON,GIE
        BSF     INTCON,GIE			;ȫжʹ
        GOTO    main

;-----------------------------------------------------------------------------------
;		Socket Buffer
;-----------------------------------------------------------------------------------
init_socket:
        BSF     STATUS,IRP
        MOVLW   skb
        MOVWF   FSR
        MOVLW   0x40
        MOVWF   com_cn
init_socket0:
        CLRF    INDF
        INCF    FSR,F
        DECFSZ  com_cn,F
        GOTO    init_socket0 & 0x7ff
        MOVLW   LOW on_ether
        MOVWF   FSR
        MOVLW   SERIAL_PACKET_SIZE-2
        MOVWF   com_cn
init_on_ether0:
        CLRF    INDF
        INCF    FSR,F
        DECFSZ  com_cn,F
        GOTO    init_on_ether0 & 0x7ff
        BCF     STATUS,IRP
        RETURN

;-----------------------------------------------------------------------------------
;		PIC16F877EEPROMжȡIPַ
;-----------------------------------------------------------------------------------
get_ip_address:
        BSF     STATUS,RP0
        MOVLW   this_ip
        MOVWF   FSR
        MOVLW   0x04
        MOVWF   common
        BSF     STATUS,RP1
        BCF     STATUS,RP0
        CLRF    EEADR & 0x7F
get_ip_address0:
        BSF     STATUS,RP1
        BSF     STATUS,RP0
        BCF     EECON1 & 0x7F,EEPGD
        BSF     EECON1 & 0x7F,RD
        BCF     STATUS,RP0
        MOVF    EEDATA & 0x7F,W
        INCF    EEADR & 0x7F,F
        BCF     STATUS,RP1
        MOVWF   INDF
        INCF    FSR,F
        DECFSZ  common,F
        GOTO    get_ip_address0 & 0x7ff

        MOVLW   ident
        MOVWF   FSR
        CLRF    INDF
        INCF    FSR,F
        CLRF    INDF
        RETURN

;-----------------------------------------------------------------------------------
;		PIC16F877EEPROMжȡPort
;-----------------------------------------------------------------------------------
get_port_no:
        MOVLW   http_port
        MOVWF   FSR
        MOVLW   0x08
        MOVWF   common
        BSF     STATUS,RP1
        BCF     STATUS,RP0
        MOVLW   0x10
        MOVWF   EEADR & 0x7F
get_port_no0:
        BSF     STATUS,RP0
        BCF     EECON1 & 0x7F,EEPGD
        BSF     EECON1 & 0x7F,RD
        BCF     STATUS,RP0
        MOVF    EEDATA & 0x7F,W
        MOVWF   INDF
        INCF    FSR,F
        INCF    EEADR & 0x7F,F
        DECFSZ  common,F
        GOTO    get_port_no0 & 0x7ff
        BCF     STATUS,RP1
        RETURN

;-----------------------------------------------------------------------------------
;		ʼTCPк
;-----------------------------------------------------------------------------------
clear_seq_no:
        BSF     STATUS,RP0
        CLRF    seq_no & 0x7F
        CLRF    seq_no+1
        CLRF    seq_no+2
        CLRF    seq_no+3
        BCF     STATUS,RP0
        RETURN

;-----------------------------------------------------------------------------------
;		ʼLCDģ
;-----------------------------------------------------------------------------------
init_lcd:
        MOVLW   0x0F
        MOVWF   wait_cn				;Wait 15ms
        CALL    wait_ms & 0x7ff

        BCF     PORTB,RB2
        MOVLW   0x30
        MOVWF   d8
        CALL    write_lcd8 & 0x7ff
        MOVLW   0x05
        MOVWF   wait_cn				;Wait 4.1ms
        CALL    wait_ms & 0x7ff

        MOVLW   0x30
        MOVWF   d8
        CALL    write_lcd8 & 0x7ff

        MOVLW   0x64
        MOVWF   wait_cn				;Wait 100us
        CALL    wait_us & 0x7ff

        MOVLW   0x30
        MOVWF   d8
        CALL    write_lcd8 & 0x7ff

        MOVLW   0x20
        MOVWF   d8
        CALL    write_lcd8 & 0x7ff

        MOVLW   0x28				;duty, font set9
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff

        MOVLW   0x01				;Clear command
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff
        MOVLW   0x02
        MOVWF   wait_cn
        CALL    wait_ms & 0x7ff			;2msԱ

        MOVLW   0x06				;Entry Mode set
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff

        MOVLW   0x0E				;display on,cursor on
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff
        RETURN

;-----------------------------------------------------------------------------------
;		8bitʽLCDд
;-----------------------------------------------------------------------------------
write_lcd8:
        BTFSS   use,0				;LCDǷЧ
        GOTO    lcd_skip & 0x7ff

        MOVF    PORTB,W
        MOVWF   tmp
        MOVLW   0x0F
        ANDWF   tmp,F
        MOVLW   0xF0
        ANDWF   d8,F
        MOVF    d8,W
        IORWF   tmp,F
        MOVF    tmp,W
        MOVWF   PORTB
        GOTO    $+1
        BSF     PORTB,RB3
        GOTO    $+1
        BCF     PORTB,RB3
lcd_skip:
        MOVLW   0x28
        MOVWF   wait_cn
        CALL    wait_us & 0x7ff
        RETURN

;-----------------------------------------------------------------------------------
;		4bitʽLCDд
;-----------------------------------------------------------------------------------
write_lcd4:
        MOVF    d4,W
        MOVWF   d8
        CALL    write_lcd8 & 0x7ff
        MOVF    d4,W
        MOVWF   d8
        SWAPF   d8,F
        CALL    write_lcd8 & 0x7ff
        RETURN

;-----------------------------------------------------------------------------------
;		LCDʾ16Ƶ
;-----------------------------------------------------------------------------------
print_hex
        BSF     RS
        SWAPF   cd,W
        CLRF    PCLATH
        CALL    getascii
        MOVWF   d4
        CALL    write_lcd4
        MOVF    cd,W
        CLRF    PCLATH
        CALL    getascii
        MOVWF   d4
        CALL    write_lcd4
        RETURN

;-----------------------------------------------------------------------------------
;		ԺΪλĵȴ
;-----------------------------------------------------------------------------------
wait_ms:
wait_ms0:
        MOVLW   0x00
        MOVWF   wait_cn2
wait_ms1
        goto $+1
        goto $+1
        goto $+1
        goto $+1
        goto $+1
        goto $+1
        goto $+1
        DECFSZ  wait_cn2,F
        GOTO    wait_ms1 & 0x7ff
        DECFSZ  wait_cn,F
        GOTO    wait_ms0 & 0x7ff
        RETURN

;-----------------------------------------------------------------------------------
;		΢Ϊλĵȴ
;-----------------------------------------------------------------------------------
wait_us:
wait_us0:
        GOTO    $+1
        DECFSZ  wait_cn,F
        GOTO    wait_us0 & 0x7ff
        RETURN

;-----------------------------------------------------------------------------------
;		32λ2Ʊ任λ10
;-----------------------------------------------------------------------------------
put_decimal32
        MOVF    FSR,W
        MOVWF   save_fsr
        MOVLW   decimal_top
        MOVWF   FSR
        BSF     STATUS,IRP
        CALL    divide32
        CALL    divide32
        CALL    divide32
        CALL    divide32
        CALL    divide32
        CALL    divide32
        CALL    divide32
        CALL    divide32
        CALL    divide32
        CALL    divide32
        MOVLW   0x09
        MOVWF   val_cn
        GOTO    put_decimal_ent

;-----------------------------------------------------------------------------------
;		16λ2Ʊ任λ10
;-----------------------------------------------------------------------------------
put_decimal16
        MOVF    FSR,W
        MOVWF   save_fsr
        MOVLW   decimal_top
        MOVWF   FSR
        BSF     STATUS,IRP
        CALL    divide16
        CALL    divide16
        CALL    divide16
        CALL    divide16
        CALL    divide16

        MOVLW   0x04
        MOVWF   val_cn
        GOTO    put_decimal_ent

;-----------------------------------------------------------------------------------
;		8λ2Ʊ任λ10
;-----------------------------------------------------------------------------------
put_decimal
        MOVWF   val
        MOVF    FSR,W
        MOVWF   save_fsr
        MOVLW   decimal_top
        MOVWF   FSR
        BSF     STATUS,IRP
        CALL    divide
        CALL    divide
        CALL    divide

        MOVLW   0x02
        MOVWF   val_cn
put_decimal_ent
        CLRF    val_m
put_decimal0
        MOVLW   0x00
        SUBWF   val_m,W
        BTFSS   STATUS,Z
        GOTO    put_decimal1
        MOVLW   '0'
        SUBWF   INDF,W
        BTFSC   STATUS,Z
        GOTO    put_decimal2
put_decimal1
        MOVF    INDF,W
        MOVWF   mdata
        CALL    puttty				;,Ŀĵdest
        MOVLW   HIGH $
        MOVWF   PCLATH

        INCF    val_m,F
put_decimal2
        INCF    FSR,F
        DECFSZ  val_cn,F
        GOTO    put_decimal0

        MOVF    INDF,W
        MOVWF   mdata
        CALL    puttty				;,Ŀĵdest
        MOVLW   HIGH $
        MOVWF   PCLATH

        BCF     STATUS,IRP
        MOVF    save_fsr,W
        MOVWF   FSR
        RETURN

;-----------------------------------------------------------------------------------
;		8λ210ʽLCDʾ
;-----------------------------------------------------------------------------------
print_dec:
        MOVWF   val
        MOVF    FSR,W
        MOVWF   save_fsr			;FSRĴ
        MOVLW   LOW decimal_top			;ʼ洢ַ
        MOVWF   FSR
        BSF     STATUS,IRP
        CALL    divide & 0x7ff			;λ任
        CALL    divide & 0x7ff
        CALL    divide & 0x7ff			;λ任
        BSF     RS
        MOVF    INDF,W
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff
        BCF     STATUS,IRP
        MOVF    save_fsr,W
        MOVWF   FSR
        RETURN
;-----------------------------------------------------------------------------------
;		8bit
;-----------------------------------------------------------------------------------
divide:
        MOVLW   0x08
        MOVWF   gcn1
        CLRF    val_m
divide0:
        BCF     STATUS,C
        RLF     val,F
        RLF     val_m,F
        MOVLW   b'11110110'
        ADDWF   val_m,W
        BTFSC   STATUS,C
        MOVWF   val_m
        BTFSC   STATUS,C
        INCF    val,F
        DECFSZ  gcn1,F
        GOTO    divide0 & 0x7ff
        DECF    FSR,F
        MOVF    val_m,W
        MOVWF   INDF
        MOVLW   0x30
        ADDWF   INDF,F
        RETURN
;-----------------------------------------------------------------------------------
;		16bit
;-----------------------------------------------------------------------------------
divide16
        MOVLW   0x10
        MOVWF   gcn1
        CLRF    val_m
divide16_0
        BCF     STATUS,C
        RLF     val,F
        RLF     val+1,F
        RLF     val_m,F
        MOVLW   b'11110110'
        ADDWF   val_m,W
        BTFSC   STATUS,C
        MOVWF   val_m
        BTFSC   STATUS,C
        INCF    val,F
        DECFSZ  gcn1,F
        GOTO    divide16_0
        DECF    FSR,F
        MOVF    val_m,W
        MOVWF   INDF
        MOVLW   0x30
        ADDWF   INDF,F
        RETURN
;-----------------------------------------------------------------------------------
;		32bit
;-----------------------------------------------------------------------------------
divide32
        MOVLW   0x20
        MOVWF   gcn1
        CLRF    val_m
divide32_0:
        BCF     STATUS,C
        RLF     val,F
        RLF     val+1,F
        RLF     val+2,F
        RLF     val+3,F
        RLF     val_m,F
        MOVLW   b'11110110'
        ADDWF   val_m,W
        BTFSC   STATUS,C
        MOVWF   val_m
        BTFSC   STATUS,C
        INCF    val,F
        DECFSZ  gcn1,F
        GOTO    divide32_0
        DECF    FSR,F
        MOVF    val_m,W
        MOVWF   INDF
        MOVLW   0x30
        ADDWF   INDF
        RETURN

;===================================================================================
;		Bootstrap Message Routine
;===================================================================================
get_lcdmes:
        MOVLW   HIGH lcd_mes
        MOVWF   PCLATH
        MOVF    wk,W
        MOVWF   PCL
;
;	BOOTSTRAP MODE Entry
;
bootstrap:
        MOVLW   HIGH $
        MOVWF   PCLATH
        MOVLW   0xC0
        MOVWF   d4
        BCF     PORTB,RB2
        CALL    write_lcd4 & 0x7ff		;ƶ2
        MOVLW   0x10
        MOVWF   gcn1
        MOVLW   low lcd_mes
        MOVWF   wk
bootstrap10:
        CALL    get_lcdmes & 0x7ff		;LCDʾ'Bootstrap Mode'
        MOVWF   d4
        MOVLW   HIGH $
        MOVWF   PCLATH
        BSF     RS
        CALL    write_lcd4 & 0x7ff
        MOVLW   HIGH $
        MOVWF   PCLATH
        INCF    wk,F
        DECFSZ  gcn1,F
        GOTO    bootstrap10 & 0x7ff
;
;	ASYNCĳʼ
;
        BSF     STATUS,RP0
        MOVLW   b'10100000'
        MOVWF   TRISC
        MOVLW   b'00100110'
        MOVWF   TXSTA				;Ų
        MOVLW   BAUD_RATE			;ò
        MOVWF   SPBRG
        BSF     PIE1 & 0x7F,RCIE		;жʹ
        BCF     STATUS,RP0
        MOVLW   b'10010000'
        MOVWF   RCSTA

        MOVLW   LOW async_transmit		;ų趨
        MOVWF   dest
        MOVLW   HIGH async_transmit
        MOVWF   dest+1

        BSF     INTCON,PEIE			;Χ豸жʹ
        BSF     INTCON,GIE			;ȫжʹ

        MOVLW   LOW bs_1			;ʾMessage
        MOVWF   com_cn
        CALL    put_bs_text & 0x7ff

        MOVLW   LOW bs_config			;ʾڵ
        MOVWF   com_cn
        CALL    put_bs_text & 0x7ff

        MOVLW   LOW bs_prompt			;ʾʾ
        MOVWF   com_cn
        CALL    put_bs_text & 0x7ff

;-----------------------------------------------------------------------------------
;		BootstrapMain Loop
;-----------------------------------------------------------------------------------
        BSF     STATUS,RP0

bootstrap0:
        MOVLW   0x00
        SUBWF   fifo_cn & 0x7F,W
        BTFSC   STATUS,Z			;ȴ(յ,զfifi_cn!=0)
        GOTO    bootstrap0 & 0x7ff
        MOVF    fifo_poi & 0x7F,W		;ȡָ
        MOVWF   FSR
        MOVF    INDF,W				;ȡ
        MOVWF   mdata
        INCF    fifo_poi & 0x7F,F		;buffer
        MOVLW   fifo_bottom
        SUBWF   fifo_poi & 0x7F,W
        BTFSS   STATUS,C
        GOTO    ring1_1 & 0x7ff
        MOVLW   fifo_top
        MOVWF   fifo_poi & 0x7F
ring1_1:
        DECF    fifo_cn & 0x7F,F		;ݼbyte
        MOVLW   0x08
        SUBWF   mdata,W				;ǷBS?
        BTFSC   STATUS,Z
        GOTO    boots_bs & 0x7ff
        BCF     STATUS,RP0
        CALL    async_transmit & 0x7ff		;
        BSF     STATUS,RP0
        MOVLW   0x0D
        SUBWF   mdata,W				;سĳ...
        BTFSC   STATUS,Z
        GOTO    boots_cr & 0x7ff
        INCF    fifo_line_cn & 0x7F,F
        GOTO    bootstrap0 & 0x7ff		;صmail loop

;-----------------------------------------------------------------------------------
;		BackSpaceŴ
;-----------------------------------------------------------------------------------
boots_bs:
        MOVLW   0x00
        SUBWF   fifo_line_cn & 0x7F,W		;ûɾʱʲôҲ
        BTFSC   STATUS,Z
        GOTO    bootstrap0 & 0x7ff
        MOVF    fifo_poi & 0x7F,W
        MOVWF   FSR
        DECF    FSR,F
        MOVLW   fifo_top
        SUBWF   FSR,W
        BTFSC   STATUS,C
        GOTO    boots_bs1 & 0x7ff
        MOVLW   fifo_bottom-1
        MOVWF   FSR
boots_bs1:
        CLRF    INDF				;BS
        MOVF    fifo_line & 0x7F,W
        MOVWF   FSR
        MOVF    fifo_line_cn & 0x7F,W
        ADDWF   FSR,F
        DECF    FSR,F
        MOVLW   fifo_bottom
        SUBWF   FSR,W
        BTFSS   STATUS,C
        GOTO    boots_bs2 & 0x7ff
        MOVLW   fifo_top
        SUBWF   FSR,F
boots_bs2:
        CLRF    INDF				;ǰַ
        BCF     STATUS,IRP
        BCF     STATUS,RP0
        CALL    async_transmit & 0x7ff		;Ϊ˻,BSַ
        MOVLW   ' '
        MOVWF   mdata
        CALL    async_transmit & 0x7ff		;ʾո
        MOVLW   0x08
        MOVWF   mdata
        CALL    async_transmit & 0x7ff		;ʾһBSַ
        BSF     STATUS,RP0
        DECF    fifo_line_cn & 0x7F,F
        GOTO    bootstrap0 & 0x7ff

;-----------------------------------------------------------------------------------
;		CRŴ
;-----------------------------------------------------------------------------------
boots_cr:
        MOVLW   0x0A
        MOVWF   mdata
        BCF     STATUS,RP0
        CALL    async_transmit & 0x7ff		;Ըз
        BSF     STATUS,RP0
        MOVLW   0x00
        SUBWF   fifo_line_cn & 0x7F,W
        BTFSS   STATUS,Z                        ;ûκ?
        GOTO    bs_job & 0x7ff
bootstrap9:
        BCF     STATUS,RP0
        MOVLW   bs_prompt & 0x00ff		; ʾϢ
        MOVWF   com_cn
        CALL    put_bs_text & 0x7ff
        BSF     STATUS,RP0
        MOVF    fifo_poi & 0x7F,W
        MOVWF   fifo_bottom & 0x7F
        CLRF    fifo_line_cn & 0x7F
        GOTO    bootstrap0 & 0x7ff		; صmain loop
; Чʱ
bootstrap99:
        BCF     STATUS,RP0
        MOVLW   bs_invalid & 0x00ff
        MOVWF   com_cn
        CALL    put_bs_text & 0x7ff
        GOTO    bootstrap9 & 0x7ff
get_bs_str:
        MOVLW   HIGH get_bs_job
        MOVWF   PCLATH
        MOVF    bs_ptr & 0x7F,W
        GOTO    get_bs_job & 0x7ff
get_bs_str2:
        MOVLW   0x1F				;ûñ?
        MOVWF   PCLATH
        MOVF    ne_next & 0x7F,W
        MOVWF   PCL                             ;0x02   ;H_1FFF

;-----------------------------------------------------------------------------------
;		ķ
;-----------------------------------------------------------------------------------
bs_job:
        MOVF    fifo_line,W
        MOVWF   save_line
        MOVF    fifo_line_cn,W
        MOVWF   save_cn
        CLRF    bs_ptr
bs_job10:
        CALL    get_bs_str & 0x7ff
        MOVWF   bs_ptr2
        MOVLW   HIGH $
        MOVWF   PCLATH

        MOVLW   0x00
        SUBWF   bs_ptr2 & 0x7F,W
        BTFSC   STATUS,Z
        GOTO    bootstrap99 & 0x7ff
bs_job0:
        CALL    get_bs_str2 & 0x7ff
        MOVWF   wk
        MOVLW   HIGH $
        MOVWF   PCLATH
        MOVLW   0x00
        SUBWF   wk,W
        BTFSC   STATUS,Z
        GOTO    bs_job1 & 0x7ff

        CALL    getterm & 0x7ff
        BSF     STATUS,RP0

        MOVLW   0x0D
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    bs_job2 & 0x7ff
        MOVF    mdata,W
        SUBWF   wk,W
        BTFSS   STATUS,Z
        GOTO    bs_job2 & 0x7ff

        INCF    bs_ptr2 & 0x7F,F
        GOTO    bs_job0 & 0x7ff
bs_job2:
        MOVLW   0x02
        ADDWF   bs_ptr & 0x7F,F
        MOVF    save_line & 0x7F,W
        MOVWF   fifo_line & 0x7F
        MOVF    save_cn & 0x7F,W
        MOVWF   fifo_line_cn & 0x7F
        GOTO    bs_job10 & 0x7ff
bs_job1:
        INCF    bs_ptr & 0x7F,F
        CALL    get_bs_str & 0x7ff
        MOVWF   wk

        BCF     STATUS,RP0
        MOVLW   0x0E
        MOVWF   PCLATH
        MOVF    wk,W
        MOVWF   PCL

;-----------------------------------------------------------------------------------
;		'initialize'
bsj_init:
        CALL    initial_values
bsj_config:
        MOVLW   bs_config & 0x00ff
        MOVWF   com_cn
        CALL    put_bs_text
        GOTO    bootstrap9
;-----------------------------------------------------------------------------------
;		ִ'help' 
bsj_help
        MOVLW   bs_help & 0x00ff
        MOVWF   com_cn
        CALL    put_bs_text
        GOTO    bootstrap9

;-----------------------------------------------------------------------------------
;		ո
skip_space
        CALL    getterm
        MOVLW   ' '
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    skip_space
        MOVLW   0x09
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    skip_space
        RETURN

;-----------------------------------------------------------------------------------
;		ִ'lcd=xxxxx'
bsj_lcd
        MOVLW   0x12
        MOVWF   wk
        GOTO    bs_set_word

;-----------------------------------------------------------------------------------
;		ִ'para=xxxxx'
bsj_para
        MOVLW   0x14
        MOVWF   wk
        GOTO    bs_set_word

;-----------------------------------------------------------------------------------
;		ִ'serial=xxxxx'
bsj_serial
        MOVLW   0x16
        MOVWF   wk
        GOTO    bs_set_word

;-----------------------------------------------------------------------------------
;		ִ'http=xxxxx'
bsj_http
        MOVLW   0x10
        MOVWF   wk
bs_set_word
        MOVLW   'w'
        MOVWF   ind
        MOVLW   0x01
        MOVWF   byte_cn
        GOTO    bs_set_common

;-----------------------------------------------------------------------------------
;		ִ'net=xxxxx'
bsj_net
        MOVLW   0x04
        MOVWF   wk
        GOTO    bs_set_byte

;-----------------------------------------------------------------------------------
;		ִ'gate=xxxxx'
bsj_gate
        MOVLW   0x08
        MOVWF   wk
        GOTO    bs_set_byte

;-----------------------------------------------------------------------------------
;		ִ'ip=xxx.xxx.xxx.xxx'
bsj_ip
        MOVLW   0x00				;EEPROMַ=0
        MOVWF   wk
bs_set_byte
        MOVLW   'b'
        MOVWF   ind
        MOVLW   0x04
        MOVWF   byte_cn
bs_set_common
        CALL    skip_space
        MOVLW   0x0D
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    put_bs_err
        MOVLW   '='
        SUBWF   mdata,W
        BTFSS   STATUS,Z
        GOTO    put_bs_err

        CALL    skip_space
        MOVLW   0x0D
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    put_bs_err

        CLRF    wk+1
        CLRF    wk+2
        GOTO    bs_getnumber
bs_getnumber0:
        CALL    getterm
bs_getnumber:
        MOVLW   0x0D
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    bs_write9			;ǻسĻͽ

        MOVLW   '.'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    bs_write
        MOVLW   ','
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    bs_write
        MOVLW   '0'
        SUBWF   mdata,W
        BTFSS   STATUS,C
        GOTO    bs_write
        MOVLW   0xC6
        ADDWF   mdata,W
        BTFSC   STATUS,C
        GOTO    bs_write
        CALL    multiply_added
        GOTO    bs_getnumber0
bs_write:
        CALL    write_eeprom
        DECF    byte_cn,F
        MOVLW   0x00
        SUBWF   byte_cn,W
        BTFSC   STATUS,Z
        GOTO    bootstrap9
        CLRF    wk+1
        CLRF    wk+2
        GOTO    bs_getnumber0
bs_write9:
        CALL    write_eeprom
        GOTO    bootstrap9

;-----------------------------------------------------------------------------------
;		LineBufferжһַ(նCR)
;-----------------------------------------------------------------------------------
getterm:
        BSF     STATUS,RP0
getterm0:
        MOVF    fifo_line,W
        MOVWF   FSR
        MOVF    INDF,W
        MOVWF   mdata

        INCF    fifo_line,F
        MOVLW   fifo_bottom
        SUBWF   fifo_line,W
        BTFSS   STATUS,C
        GOTO    getterm1
        MOVLW   fifo_top
        MOVWF   fifo_line
getterm1:
        DECF    fifo_line_cn & 0x7F,F
        MOVLW   0x00
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    getterm0 & 0x7ff
        BCF     STATUS,RP0
        RETURN
put_bs_err
        MOVLW   bs_err
        MOVWF   com_cn
        CALL    put_bs_text
        GOTO    bootstrap9

;-----------------------------------------------------------------------------------
;		Bootstrapõ
;-----------------------------------------------------------------------------------
put_bs_text:
        BSF     STATUS,RP1
        BCF     STATUS,RP0
        MOVLW   0x13
        MOVWF   EEADRH & 0x7F
        MOVF    com_cn,W
        MOVWF   EEADR & 0x7F
        BSF     STATUS,RP0
        BSF     EECON1 & 0x7F,EEPGD
        BSF     EECON1 & 0x7F,RD
        NOP
        NOP
        BCF     STATUS,RP0
        MOVF    EEDATH & 0x7F,W
        MOVWF   getmes_wk
        MOVF    EEDATA & 0x7F,W
        MOVWF   getmes_wk+1
        BCF     STATUS,RP1

        RLF     getmes_wk+1,W
        RLF     getmes_wk,F
        MOVF    getmes_wk,W
        ANDLW   0x7F
        BTFSC   STATUS,Z
        GOTO    put_bs_text9 & 0x7ff
        MOVWF   mdata
        MOVLW   '$'
        SUBWF   mdata,W
        BTFSC   STATUS,Z
        GOTO    ctrl_code & 0x7ff
        CALL    async_transmit & 0x7ff
        MOVF    getmes_wk+1,W
        ANDLW   0x7F
        BTFSC   STATUS,Z
        GOTO    put_bs_text9 & 0x7ff
        MOVWF   mdata
        CALL    async_transmit & 0x7ff
        INCF    com_cn,F
        GOTO    put_bs_text & 0x7ff
put_bs_text9:
        RETURN

;-----------------------------------------------------------------------------------
;		RS232C
;-----------------------------------------------------------------------------------
async_transmit:
        BTFSS   PIR1,TXIF
        GOTO    async_transmit & 0x7ff
        MOVF    mdata,W
        MOVWF   TXREG
        RETURN

;-----------------------------------------------------------------------------------
;		Ʒ
;-----------------------------------------------------------------------------------
;		org	0f00h
ctrl_code:
        MOVLW   HIGH ctrl_code1
        MOVWF   PCLATH
        MOVF    getmes_wk+1,W
        ANDLW   0x7F
        ADDLW   0xD0
        CALL    ctrl_code1 & 0x7ff
        INCF    com_cn,F
        GOTO    put_bs_text & 0x7ff
ctrl_code1:
        ADDWF   PCL,F
	goto	put_mac_address		; 0:MACɥ쥹
	goto	put_ip_address		; 1:IPɥ쥹
	goto	put_netmask		; 2:ͥåȥޥ
	goto	put_gateway_address	; 3:`ȥ
	goto	put_http_port		; 4:httpݩ`
	goto	put_lcd_port		; 5:lcdݩ`
	goto	put_io_port		; 6:parallelݩ`
	goto	put_232_port		; 7:232cݩ`
	goto	put_version		; 8:Щ`ʾ
	goto	put_send_packet		; 9:ťѥå
	goto	put_this_ip		; A:ԣɣФαʾ
	goto	put_ptop		; B:PtoP IPɥ쥹

put_send_packet
        MOVLW   ident
        MOVWF   FSR
        MOVF    INDF,W
        MOVWF   val+1
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   val
        INCF    FSR,F
        MOVLW   0x00
        MOVWF   val+2
        INCF    FSR,F
        MOVLW   0x00
        MOVWF   val+3
        GOTO    put_decimal32		; ťѥåʾ

put_http_port
        BSF     STATUS,RP1
        MOVLW   0x10
        MOVWF   EEADR
        GOTO    putcom16

put_lcd_port
        BSF     STATUS,RP1
        MOVLW   0x12
        MOVWF   EEADR
        GOTO    putcom16

put_io_port
        BSF     STATUS,RP1
        MOVLW   0x14
        MOVWF   EEADR
        GOTO    putcom16

put_232_port
        BSF     STATUS,RP1
        MOVLW   0x16
        MOVWF   EEADR
putcom16
        GOTO    put_number16

put_this_ip
        MOVLW   this_ip
        MOVWF   FSR
        MOVLW   0x04
        MOVWF   common
        CALL    put_number_fr
        RETURN

put_ptop
        BSF     STATUS,RP1
        MOVLW   0x18
        MOVWF   EEADR
        GOTO    putcom32

put_ip_address
        BSF     STATUS,RP1
        CLRF    EEADR
        GOTO    putcom32

put_netmask
        BSF     STATUS,RP1
        MOVLW   0x04
        MOVWF   EEADR
        GOTO    putcom32

put_gateway_address
        BSF     STATUS,RP1
        MOVLW   0x08
        MOVWF   EEADR
        GOTO    putcom32

put_version
        BSF     STATUS,RP1
        MOVLW   0x0C
        MOVWF   EEADR
putcom32
        MOVLW   0x04
        MOVWF   common
        GOTO    put_number
        RETURN

;-----------------------------------------------------------------------------------
;		ⲿݩ`Ȥ˳
;-----------------------------------------------------------------------------------
puttty
        MOVF    dest+1,W
        MOVWF   PCLATH
        MOVF    dest,W
        MOVWF   PCL

;-----------------------------------------------------------------------------------
;		'.' ФǣӥåȣMEEPROMȡãʾ
;-----------------------------------------------------------------------------------
put_number0

        MOVLW   '.'
        MOVWF   mdata
        CALL    puttty
        MOVLW   HIGH $
        MOVWF   PCLATH

put_number
        BSF     STATUS,RP1
        BSF     STATUS,RP0
        BCF     EECON1,EEPGD
        BSF     EECON1,RD
        BCF     STATUS,RP0
        MOVF    EEDATA,W
        MOVWF   mdata
        INCF    EEADR,F
        BCF     STATUS,RP1

        MOVF    mdata,W
        CALL    put_decimal
        DECFSZ  common,F
        GOTO    put_number0
        RETURN

;-----------------------------------------------------------------------------------
;		'.' ФǣӥåȣMʾ
;-----------------------------------------------------------------------------------
put_number_fr0
        MOVLW   '.'
        MOVWF   mdata
        CALL    puttty
        MOVLW   HIGH $
        MOVWF   PCLATH

put_number_fr
        MOVF    INDF,W
        INCF    FSR,F
        CALL    put_decimal
        DECFSZ  common,F
        GOTO    put_number_fr0
        RETURN


;-----------------------------------------------------------------------------------
;		EEPROM飱ӥåȂȡãMʾ
;-----------------------------------------------------------------------------------
put_number16
        BSF     STATUS,RP1
        BSF     STATUS,RP0
        BCF     EECON1,EEPGD
        BSF     EECON1,RD
        BCF     STATUS,RP0
        MOVF    EEDATA,W
        INCF    EEADR,F
        BCF     STATUS,RP1
        MOVWF   val+1

        BSF     STATUS,RP1
        BSF     STATUS,RP0
        BCF     EECON1,EEPGD
        BSF     EECON1,RD
        BCF     STATUS,RP0
        MOVF    EEDATA,W
        INCF    EEADR,F
        BCF     STATUS,RP1
        MOVWF   val

        CALL    put_decimal16
        RETURN

;-----------------------------------------------------------------------------------
;		M`
;-----------------------------------------------------------------------------------
put_hexadecimal

        CLRF    PCLATH
        SWAPF   cd,W
        CALL    getascii
        MOVWF   mdata
        MOVLW   HIGH puttty
        MOVWF   PCLATH
        CALL    puttty
        CLRF    PCLATH
        MOVF    cd,W
        CALL    getascii
        MOVWF   mdata
        MOVLW   HIGH puttty
        MOVWF   PCLATH
        CALL    puttty
        MOVLW   HIGH $
        MOVWF   PCLATH
        RETURN

;-----------------------------------------------------------------------------------
;		ʾMACַ
;-----------------------------------------------------------------------------------
put_mac_address

        MOVLW   mymac
        MOVWF   FSR
        MOVF    INDF,W
        MOVWF   cd
        INCF    FSR,F
        CALL    put_hexadecimal

        MOVLW   '-'
        MOVWF   mdata
        CALL    puttty
        MOVLW   HIGH put_hexadecimal
        MOVWF   PCLATH

        MOVF    INDF,W
        MOVWF   cd
        INCF    FSR,F
        CALL    put_hexadecimal

        MOVLW   '-'
        MOVWF   mdata
        CALL    puttty
        MOVLW   HIGH put_hexadecimal
        MOVWF   PCLATH

        MOVF    INDF,W
        MOVWF   cd
        INCF    FSR,F
        CALL    put_hexadecimal

        MOVLW   '-'
        MOVWF   mdata
        CALL    puttty
        MOVLW   HIGH put_hexadecimal
        MOVWF   PCLATH

        MOVF    INDF,W
        MOVWF   cd
        INCF    FSR,F
        CALL    put_hexadecimal

        MOVLW   '-'
        MOVWF   mdata
        CALL    puttty
        MOVLW   HIGH put_hexadecimal
        MOVWF   PCLATH

        MOVF    INDF,W
        MOVWF   cd
        INCF    FSR,F
        CALL    put_hexadecimal

        MOVLW   '-'
        MOVWF   mdata
        CALL    puttty
        MOVLW   HIGH put_hexadecimal
        MOVWF   PCLATH

        MOVF    INDF,W
        MOVWF   cd
        INCF    FSR,F
        CALL    put_hexadecimal

        RETURN


;-----------------------------------------------------------------------------------
;		LCDʾIPַ
;-----------------------------------------------------------------------------------
print_ip:
        MOVLW   HIGH print_dec
        MOVWF   PCLATH
        MOVLW   this_ip
        MOVWF   FSR

        MOVF    INDF,W
        INCF    FSR,F
        CALL    print_dec & 0x7ff

        MOVLW   '.'
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff

        MOVF    INDF,W
        INCF    FSR,F
        CALL    print_dec & 0x7ff

        MOVLW   '.'
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff

        MOVF    INDF,W
        INCF    FSR,F
        CALL    print_dec & 0x7ff

        MOVLW   '.'
        MOVWF   d4
        CALL    write_lcd4 & 0x7ff

        MOVF    INDF,W
        INCF    FSR,F
        CALL    print_dec & 0x7ff
        RETURN


;-----------------------------------------------------------------------------------
;		עᷢʹݵĿĵ
;-----------------------------------------------------------------------------------
;
        ORG     0x1000
;
ser_register
        MOVLW   SERIAL_PACKET_SIZE-2
        MOVWF   wk
        CLRF    wk+1
        BSF     STATUS,IRP
        MOVLW   on_ether & 0xff
        MOVWF   FSR
ser_register0
        MOVF    INDF,W
        IORWF   wk+1,F
        INCF    FSR,F
        DECFSZ  wk,F
        GOTO    ser_register0
        BCF     STATUS,IRP

        MOVLW   0x00
        SUBWF   wk+1,W
        BTFSS   STATUS,Z
        GOTO    ser_register9

        BSF     STATUS,IRP
        MOVLW   on_ip & 0xff
        MOVWF   FSR

        MOVF    udp_data+1,W
        MOVWF   INDF
        INCF    FSR,F

        MOVF    udp_data+2,W
        MOVWF   INDF
        INCF    FSR,F

        MOVF    udp_data+3,W
        MOVWF   INDF
        INCF    FSR,F

        MOVF    udp_data+4,W
        MOVWF   INDF
        INCF    FSR,F

        MOVF    udp_src_port,W
        MOVWF   INDF
        INCF    FSR,F
        MOVF    udp_src_port+1,W
        MOVWF   INDF
        INCF    FSR,F

        MOVF    udp_data+5,W
        MOVWF   INDF
        BSF     STATUS,RP0
        MOVF    INDF,W
        MOVWF   SPBRG						;ò
        BCF     STATUS,RP0

        INCF    FSR,F
        MOVF    udp_data+6,W
        MOVWF   INDF
        MOVLW   0x00
        SUBWF   INDF,W
        BTFSS   STATUS,Z
        BSF     INTCON,INTE
        BCF     STATUS,IRP

;
;	ARP
;
        CLRF    PCLATH						;Important!

        CLRF    remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1

        MOVLW   PACKET_SIZE+ARP_SIZE
        MOVWF   remote_len
        CLRF    remote_len+1
        CALL    remote_write

        MOVLW   0x10						;Ŀĵַ'ff-ff-ff-ff-ff-ff'
        MOVWF   PORTC
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0xFF
        CALL    assert_wr

        MOVLW   mymac						;FromַΪԼMACַ
        MOVWF   FSR
        MOVLW   0x06
        CALL    transmit_nbytes

        MOVLW   COM_PROTO					;08 Ehterframe type
        CALL    assert_wr
        MOVLW   ARP_PROTO					;ARP
        CALL    assert_wr

        MOVLW   HIGH $
        MOVWF   PCLATH
        CALL    arp2						;ARP header write
        CLRF    PCLATH						;Important!

        CLRF    PORTC
        MOVLW   b'00100010'
        CALL    assert_wr0

        MOVLW   0x04
        MOVWF   PORTC
        MOVLW   PAGE_BEGIN					;transmit page is start page
        CALL    assert_wr0

        MOVLW   0x05
        MOVWF   PORTC
        MOVLW   0x3C						;minimum packet = 60
        CALL    assert_wr0

        MOVLW   0x06
        MOVWF   PORTC
        dw	0x100
        CALL    assert_wr0
        CALL    transmit
ser_register9
        MOVLW   HIGH ser_get_status
        MOVWF   PCLATH
        GOTO    ser_get_status

ser_unregister
        BCF     RCSTA,CREN
        BCF     INTCON,PEIE
        MOVLW   SERIAL_PACKET_SIZE-2
        MOVWF   wk
        CLRF    wk+1
        BSF     STATUS,IRP
        MOVLW   on_ether & 0xff
        MOVWF   FSR
ser_unregister0
        CLRF    INDF
        INCF    FSR,F
        DECFSZ  wk,F
        GOTO    ser_unregister0
        BCF     STATUS,IRP
        GOTO    ser_register9


dhcp:
        BSF     STATUS,RP0
        MOVLW   0xFF
        MOVWF   dhcp_done & 0x7F
        BCF     STATUS,RP0

        MOVLW   HIGH bootp
        MOVWF   PCLATH
        CALL    bootp & 0x7ff			;ͨDHCPȡIPַ
        CLRF    PCLATH

        MOVLW   0x35
        CALL    assert_wr
        MOVLW   0x01
        CALL    assert_wr
        MOVLW   0x01
        CALL    assert_wr

        MOVLW   0x3D
        CALL    assert_wr
        MOVLW   0x07
        CALL    assert_wr
        MOVLW   0x01
        CALL    assert_wr
        MOVLW   mymac
        MOVWF   FSR
        MOVLW   0x06
        CALL    transmit_nbytes			;ԼMACַ

        MOVLW   0xFF
        CALL    assert_wr
        MOVLW   0x2F
        MOVWF   gcn1

bootp_30:
        CLRF    PCLATH
        dw	0x100
        CALL    assert_wr

        MOVLW   HIGH $
        MOVWF   PCLATH
        DECFSZ  gcn1,F
        GOTO    bootp_30 & 0x7ff
        MOVLW   HIGH bootp_tx
        MOVWF   PCLATH
        CALL    bootp_tx & 0x7ff
        RETURN

;-----------------------------------------------------------------------------------
;		ARPHeader
arp1:
        CLRF    PCLATH
        dw	0x100
        CALL    assert_wr
        MOVLW   0x01
        CALL    assert_wr			; Ethernet̶Ϊ1

        MOVLW   COM_PROTO
        CALL    assert_wr
        MOVLW   IP_PROTO
        CALL    assert_wr

        MOVLW   0x06				; EthernetַByte=6
        CALL    assert_wr
        MOVLW   0x04				; IPַByte=4
        CALL    assert_wr

        MOVLW   0x00
        CALL    assert_wr
        MOVLW   0x02				; ARPӦ(=2)
        CALL    assert_wr

        MOVLW   mymac
        MOVWF   FSR
        MOVLW   0x06
        CALL    transmit_nbytes			;ԼMAC
        CALL    transmit_this_ip		;ԼIP

        MOVLW   arp_src_mac			;ԷMAC
        MOVWF   FSR
        MOVLW   0x0A
        CALL    transmit_nbytes			;ͶԷIP
        RETURN

;-----------------------------------------------------------------------------------
;		ARPHeader
arp2:
        CLRF    PCLATH

        dw	0x100
        CALL    assert_wr
        MOVLW   0x01
        CALL    assert_wr

        MOVLW   COM_PROTO
        CALL    assert_wr
        MOVLW   IP_PROTO
        CALL    assert_wr

        MOVLW   0x06
        CALL    assert_wr
        MOVLW   0x04
        CALL    assert_wr

        MOVLW   0x00
        CALL    assert_wr
        MOVLW   0x01
        CALL    assert_wr

        MOVLW   mymac
        MOVWF   FSR
        MOVLW   0x06
        CALL    transmit_nbytes
        CALL    transmit_this_ip

        MOVLW   0x00
        CALL    assert_wr
        MOVLW   0x00
        CALL    assert_wr
        MOVLW   0x00
        CALL    assert_wr
        MOVLW   0x00
        CALL    assert_wr
        MOVLW   0x00
        CALL    assert_wr
        MOVLW   0x00
        CALL    assert_wr

        BSF     STATUS, IRP
        MOVLW   on_ip
        MOVWF   FSR
check_netid
        MOVLW   HIGH $
        MOVWF   PCLATH
        BSF     STATUS,RP1
        BCF     STATUS,RP0
        MOVLW   0x04
        MOVWF   EEADR
        BCF     STATUS,RP1

        CALL    getnetmask
        BSF     STATUS, RP0
        MOVF    this_ip,W
        MOVWF   wk+1
        MOVF    wk,W
        ANDWF   wk+1,F
        MOVF    INDF,W
        ANDWF   wk,F
        INCF    FSR,F
        MOVF    wk+1,W
        SUBWF   wk,W
        BTFSS   STATUS,Z
        GOTO    gateway

        CALL    getnetmask
        BSF     STATUS, RP0
        MOVF    this_ip+1,W
        MOVWF   wk+1
        MOVF    wk,W
        ANDWF   wk+1,F
        MOVF    INDF,W
        ANDWF   wk,F
        INCF    FSR,F
        MOVF    wk+1,W
        SUBWF   wk,W
        BTFSS   STATUS,Z
        GOTO    gateway

        CALL    getnetmask
        BSF     STATUS, RP0
        MOVF    this_ip+2,W
        MOVWF   wk+1
        MOVF    wk,W
        ANDWF   wk+1,F
        MOVF    INDF,W
        ANDWF   wk,F
        INCF    FSR,F
        MOVF    wk+1,W
        SUBWF   wk,W
        BTFSS   STATUS,Z
        GOTO    gateway

        CALL    getnetmask
        BSF     STATUS, RP0
        MOVF    this_ip+3,W
        MOVWF   wk+1
        MOVF    wk,W
        ANDWF   wk+1,F
        MOVF    INDF,W
        ANDWF   wk,F
        MOVF    wk+1,W
        SUBWF   wk,W
        BTFSS   STATUS,Z
        GOTO    gateway

direct
        BCF     STATUS,RP0
        BCF     STATUS,RP1
        CLRF    PCLATH
        MOVLW   on_ip
        MOVWF   FSR
        MOVLW   0x04					;ԷIPַ
        CALL    transmit_nbytes

        BCF     STATUS,IRP
        MOVLW   HIGH $
        MOVWF   PCLATH
        RETURN

gateway
        BSF     STATUS, RP1
        BCF     STATUS, RP0
        MOVLW   0x08
        MOVWF   EEADR
        BSF     STATUS, RP0
        BCF     STATUS, RP1

        MOVLW   HIGH $
        MOVWF   PCLATH
        CALL    getnetmask
        CLRF    PCLATH
        MOVF    wk,W
        CALL    assert_wr

        MOVLW   HIGH $
        MOVWF   PCLATH
        CALL    getnetmask
        CLRF    PCLATH
        MOVF    wk,W
        CALL    assert_wr

        MOVLW   HIGH $
        MOVWF   PCLATH
        CALL    getnetmask
        CLRF    PCLATH
        MOVF    wk,W
        CALL    assert_wr

        MOVLW   HIGH $
        MOVWF   PCLATH
        CALL    getnetmask
        CLRF    PCLATH
        MOVF    wk,W
        CALL    assert_wr

        BCF     STATUS,IRP
        MOVLW   HIGH $
        MOVWF   PCLATH
        RETURN

getnetmask
        BSF     STATUS,RP1
        BSF     STATUS,RP0
        BCF     EECON1,EEPGD
        BSF     EECON1,RD
        BCF     STATUS,RP0
        MOVF    EEDATA,W
        MOVWF   wk
        INCF    EEADR
        BCF     STATUS,RP1
        RETURN

;-----------------------------------------------------------------------------------
;		HostRS232
;-----------------------------------------------------------------------------------
serial_tx:
        BSF     STATUS,IRP
        MOVLW   on_ether
        MOVWF   FSR
        BSF     STATUS,RP0
        MOVF    INDF,W
        MOVWF   eth_src & 0x7F
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   eth_src+1
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   eth_src+2
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   eth_src+3
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   eth_src+4
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   eth_src+5
        INCF    FSR,F
        BCF     STATUS,RP0

        MOVF    INDF,W
        MOVWF   ip_src
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   ip_src+1
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   ip_src+2
        INCF    FSR,F
        MOVF    INDF,W
        MOVWF   ip_src+3
        INCF    FSR,F
        BCF     STATUS,IRP
;
;Ԥ
;

        BSF     STATUS,RP0
        MOVF    fifo_cn & 0x7F,W
        MOVWF   wk
        BCF     STATUS,RP0

        MOVLW   0x00
        MOVWF   ip_length
        MOVLW   IP_SIZE + UDP_SIZE
        MOVWF   ip_length+1
        MOVF    wk,W
        ADDWF   ip_length+1,F			;ݴС
        MOVLW   SERIAL_PACKET_SIZE
        ADDWF   ip_length+1,F			;ͨHeaderĴС

        CLRF    PCLATH

        MOVLW   UDP_PROTO
        MOVWF   proto				;UDPݰ
        CALL    prepare_ip			;IP

        CALL    clear_sum			;Checksumֵ

        MOVLW   PACKET_SIZE+IP_SIZE
        MOVWF   remote_adr
        MOVLW   PAGE_BEGIN
        MOVWF   remote_adr+1

        MOVLW   UDP_SIZE
        MOVWF   remote_len
        MOVLW   SERIAL_PACKET_SIZE
        ADDWF   remote_len,F
        MOVF    wk,W
        ADDWF   remote_len,F

        MOVLW   0x00
        MOVWF   remote_len+1
        CALL    remote_write

        MOVLW   0x10
        MOVWF   PORTC

        MOVLW   serial_port
        MOVWF   FSR
        MOVF    INDF,W				; From PORT #HIGH
        CALL    assert_wr
        INCF    FSR,F
        MOVF    INDF,W				; From PORT #LOW
        CALL    assert_wr

        BSF     STATUS,IRP
        MOVLW   on_port
        MOVWF   FSR
        MOVF    INDF,W
        CALL    assert_wr
        INCF    FSR,F
        MOVF    INDF,W
        CALL    assert_wr
        BCF     STATUS,IRP

        MOVLW   0x00
        CALL    assert_wr
        MOVLW   UDP_SIZE+SERIAL_PACKET_SIZE
        ADDWF   wk,W
        CALL    assert_wr

        CALL    assert_wr2times

        MOVLW   0x04
        CALL    assert_wr
        MOVF    wk,W
        ADDLW   SERIAL_PACKET_SIZE
        CALL    assert_wr			;sum(not fixed)
;
; 	Status
        BSF     STATUS,IRP
        MOVLW   on_ether
        MOVWF   FSR
        MOVLW   SERIAL_PACKET_SIZE - 2
        CALL    transmit_nbytes
        BCF     STATUS,IRP
;
; 	
serial_tx0:
        MOVLW   HIGH $
        MOVWF   PCLATH
        BSF     STATUS,RP0
        MOVF    fifo_poi & 0x7F,W
        MOVWF   FSR				;ָ
        MOVF    INDF,W
        MOVWF   mdata				;ȡյ

        INCF    fifo_poi & 0x7F,F
        MOVLW   fifo_bottom
        SUBWF   fifo_poi & 0x7F,W
        BTFSS   STATUS,C
        GOTO    tx100 & 0x7ff
        MOVLW   fifo_top
        MOVWF   fifo_poi & 0x7F
tx100:
        DECF    fifo_cn & 0x7F,F
        BCF     STATUS,RP0

        CLRF    PCLATH
        MOVF    mdata,W
        CALL    assert_wr

        MOVLW   HIGH $
        MOVWF   PCLATH
        DECFSZ  wk,F
        GOTO    serial_tx0 & 0x7ff
        BCF     PORTB,RB1
;
;	UDP Sum  + 
        MOVLW   HIGH calc_udp_sum
        MOVWF   PCLATH
        CALL    calc_udp_sum & 0x7ff

        CLRF    PCLATH
        MOVLW   0x04
        MOVWF   PORTC
        MOVLW   PAGE_BEGIN			; transmit page is start page
        CALL    assert_wr0

        MOVLW   PACKET_SIZE
        ADDWF   ip_length+1,F
        MOVLW   0x01
        BTFSC   STATUS,C
        ADDWF   ip_length,F

        MOVLW   0x06
        MOVWF   PORTC
        MOVF    ip_length,W
        CALL    assert_wr0

        MOVLW   HIGH $
        MOVWF   PCLATH
        MOVF    ip_length,F
        BTFSC   STATUS,Z
        GOTO    serial_tx1 & 0x7ff
serial_tx2:
        CLRF    PCLATH
        MOVLW   0x05
        MOVWF   PORTC
        MOVF    ip_length+1,W
        CALL    assert_wr0
        CALL    transmit			;!

        CLRF    PCLATH
        GOTO    main0
serial_tx1:
        MOVLW   0x3C
        SUBWF   ip_length+1,W
        BTFSC   STATUS,C
        GOTO    serial_tx2 & 0x7ff
        CLRF    PCLATH
        MOVLW   0x05
        MOVWF   PORTC
        MOVLW   0x3C				; Minimum 60 bytes
        CALL    assert_wr0
        CALL    transmit
        CLRF    PCLATH                          ;0x0A
        GOTO    main0

udp_lcd9:
        CLRF    PCLATH                          ;0x0A
        GOTO    main9

;-----------------------------------------------------------------------------------
;		LCDʾ
;-----------------------------------------------------------------------------------
udp_lcd:
        MOVF    udp_length,W
        MOVWF   remote_len+1
        MOVF    udp_length+1,W
        MOVWF   remote_len
        MOVLW   0x08
        SUBWF   remote_len,F
        BTFSS   STATUS,C
        DECF    remote_len+1,F

        MOVLW   HIGH get_dgram
        MOVWF   PCLATH
        CALL    get_dgram
        MOVLW   HIGH $
        MOVWF   PCLATH
        BTFSC   STATUS,C
        GOTO    udp_lcd9 & 0x7ff

        MOVLW   0x01
        SUBWF   mdata,W				; header = 1 ֱʾ, = 0 
        BTFSS   STATUS,Z
        GOTO    udp_lcd_0 & 0x7ff

        MOVLW   HIGH get_dgram
        MOVWF   PCLATH
        CALL    get_dgram
        MOVLW   HIGH $
        MOVWF   PCLATH
        BTFSC   STATUS,C
        GOTO    udp_lcd9 & 0x7ff

        MOVF    PORTB,W
        MOVWF   wk
        BCF     PORTB,RB2
        MOVF    mdata,W
        MOVWF   d4

        MOVLW   HIGH write_lcd4
        MOVWF   PCLATH
        CALL    write_lcd4 & 0x7ff
        MOVLW   HIGH $
        MOVWF   PCLATH

        MOVF    wk,W
        MOVWF   PORTB

        MOVLW   b'11111100'
        ANDWF   d4,F
        BTFSS   STATUS,Z
        GOTO    udp_lcd_0 & 0x7ff
;
;	ʾ.λ
        MOVLW   0x02
        MOVWF   wait_cn				;Լ2ms
        MOVLW   HIGH wait_ms
        MOVWF   PCLATH
        CALL    wait_ms & 0x7ff
        MOVLW   HIGH $
        MOVWF   PCLATH
udp_lcd_0:
        MOVLW   HIGH get_dgram
        MOVWF   PCLATH
        CALL    get_dgram & 0x7ff
        MOVLW   HIGH $
        MOVWF   PCLATH
        BTFSC   STATUS,C
        GOTO    udp_lcd_91 & 0x7ff

        MOVF    PORTB,W
        MOVWF   wk
        BSF     PORTB,RB2
        MOVF    mdata,W
        MOVWF   d4
        MOVLW   HIGH write_lcd4
        MOVWF   PCLATH
        CALL    write_lcd4 & 0x7ff
        MOVLW   HIGH $
        MOVWF   PCLATH
        MOVF    wk,W
        MOVWF   PORTB
        GOTO    udp_lcd_0 & 0x7ff
udp_lcd_91:
        MOVLW   lcd_port
        MOVWF   wk+2
        MOVLW   HIGH common_get_status
        MOVWF   PCLATH
        GOTO    common_get_status & 0x7ff



;-----------------------------------------------------------------------------------
;		BootStrap Message
;-----------------------------------------------------------------------------------
		org	0x1300
lcd_mes		dt	"Bootstrap Mode  "
bs_1		da	"\r\n\r\nPIC Network Interface Card - Bootstrap Mode Version $8\r\n"
		da	0
bs_prompt	da	"PICNIC>"
bs_config	da	"***** Configuration ***** \r\n"
		da	"MAC Addr.  :$0\r\n"
		da	"[I]P Addr. :$1\r\n"
		da	"[N]etMask  :$2\r\n"
		da	"[G]ateWay  :$3\r\n"
		da	"[H]ttpPort     #$4\r\n"
		da	"[L]CD Port     #$5\r\n"
		da	"[P]arallelPort #$6\r\n"
		da	"[S]erialPort   #$7\r\n"
		da	0
bs_err		da	"Syntax Error.\r\n"
bs_invalid	da	"Invalid Command.\r\n",0
bs_help
		da	"***** Bootstrap Mode Help ***** \r\n"
		da	"config         - Print Board Configuration and Status.\r\n"
		da	"{str}={value}  - Update System Configuration. \r\n"
		da	"initialize     - All registers set Initial Values.\r\n"
		da	0
;
        ORG     0x1400
		da	"HTTP/1.0 200 OK\r\nConnection: close\r\nContent-type: text/html\r\n\r\n<"
		da	"HTML><HEAD><TITLE>PIC Network Interface Card</TITLE></HEAD><BODY>\n"
		da	"<FONT SIZE=+2>PIC Network Interface Card Version  $8 </FONT>"
		da	"<HR>"

		da	"<h3>I/O Ports</h3>"
		da	"<DL><DD><FORM ACTION=\"modify.cgi\" METHOD=\"GET\">\n"
		da	"<TABLE BORDER>"
		da	"<TR><TD>Port</TD><TD>Value</TD></TR>"

		da	"<TR><TD>RA0 %\x00 </TD>"
		da	"<TD ALIGN=\"right\">@\x00</TD></TR>"

		da	"<TR><TD>RA1 %\x01 </TD>"
		da	"<TD ALIGN=\"right\">@\x01</TD></TR>"

		da	"<TR><TD>RA2 %\x02 </TD>"
		da	"<TD ALIGN=\"right\">@\x02</TD></TR>"

		da	"<TR><TD>RA3 %\x03 </TD>"
		da	"<TD ALIGN=\"right\">@\x03</TD></TR>"

		da	"<TR><TD>RA5 %\x04 </TD>"
		da	"<TD ALIGN=\"right\">@\x04 Celsius</TD></TR>"
		da	0

;------------------------------------------------------------------------------------------------
;
        ORG     0x1700
		da	"<TR><TD>RB0 %\x10 </TD>"
		da	"<TD><INPUT TYPE=\"submit\" NAME=\"RB0\" VALUE=\"H\">"
		da	"@\x10<INPUT TYPE=\"submit\" NAME=\"RB0\" VALUE=\"L\"></TD></TR>"
		da	"<TR><TD>RB1 %\x11 </TD>"
		da	"<TD><INPUT TYPE=\"submit\" NAME=\"RB1\" VALUE=\"H\">"
		da	"@\x11<INPUT TYPE=\"submit\" NAME=\"RB1\" VALUE=\"L\"></TD></TR>"
		da	"<TR><TD>RB2 %\x12 </TD>"
		da	"<TD><INPUT TYPE=\"submit\" NAME=\"RB2\" VALUE=\"H\">"
		da	"@\x12<INPUT TYPE=\"submit\" NAME=\"RB2\" VALUE=\"L\"></TD></TR>"
		da	"<TR><TD>RB3 %\x13 </TD>"
		da	"<TD><INPUT TYPE=\"submit\" NAME=\"RB3\" VALUE=\"H\">"
		da	"@\x13<INPUT TYPE=\"submit\" NAME=\"RB3\" VALUE=\"L\"></TD></TR>"


		da	"<TR><TD>RB4 %\x14 </TD>"
		da	"<TD><INPUT TYPE=\"submit\" NAME=\"RB4\" VALUE=\"H\">"
		da	"@\x14<INPUT TYPE=\"submit\" NAME=\"RB4\" VALUE=\"L\"></TD></TR>"
		da	"<TR><TD>RB5 %\x15 </TD>"
		da	"<TD><INPUT TYPE=\"submit\" NAME=\"RB5\" VALUE=\"H\">"
		da	"@\x15<INPUT TYPE=\"submit\" NAME=\"RB5\" VALUE=\"L\"></TD></TR>"
		da	"<TR><TD>RB6 %\x16 </TD>"
		da	"<TD><INPUT TYPE=\"submit\" NAME=\"RB6\" VALUE=\"H\">"
		da	"@\x16<INPUT TYPE=\"submit\" NAME=\"RB6\" VALUE=\"L\"></TD></TR>"
		da	"<TR><TD>RB7 %\x17 </TD>"
		da	"<TD><INPUT TYPE=\"submit\" NAME=\"RB7\" VALUE=\"H\">"
		da	"@\x17<INPUT TYPE=\"submit\" NAME=\"RB7\" VALUE=\"L\"></TD></TR>"
		da	"<TR><TD> </TD>"
		da	"<TD><INPUT TYPE=\"submit\" VALUE=\"Reload\"></TD></TR>"
		da	"</TABLE>"
		da	"</FORM></DL>"
		da	0

;
        ORG     0x1A00
;
		da	"<FORM METHOD=\"GET\" ACTION=\"submit.cgi\">\n"
		da	"<h3>Configuration</h3>"

		da	"<DL><DD><TABLE BORDER>"

		da	"<TR><TD>MAC Address</TD>"
		da	"<TD>$0</TD></TR>"

		da	"<TR><TD>IP Addr</TD>"
		da	"<TD><INPUT TYPE=\"text\" NAME=\"00b\"  VALUE=\""
		da	"$1\"></TD></TR>"

		da	"<TR><TD>NetMask</TD>"
		da	"<TD><INPUT TYPE=\"text\" NAME=\"04b\"  VALUE=\""
		da	"$2\"></TD></TR>"

		da	"<TR><TD>GateWay</TD>"
		da	"<TD><INPUT TYPE=\"text\" NAME=\"08b\"  VALUE=\""
		da	"$3\"></TD></TR>"

		da	"<TR><TD>http Port TCP:#</TD>"
		da	"<TD><INPUT TYPE=\"text\" NAME=\"10w\"  VALUE=\""
		da	"$4\"></TD></TR>"

		da	"<TR><TD>LCD  Port UDP:#</TD>"
		da	"<TD><INPUT TYPE=\"text\" NAME=\"12w\"  VALUE=\""
		da	"$5\"></TD></TR>"

		da	"<TR><TD>Parallel Port UDP:#</TD>"
		da	"<TD><INPUT TYPE=\"text\" NAME=\"14w\"  VALUE=\""
		da	"$6\"></TD></TR>"

		da	"<TR><TD>Serial Port UDP:#</TD>"
		da	"<TD><INPUT TYPE=\"text\" NAME=\"16w\"  VALUE=\""
		da	"$7\"></TD></TR>"
		da	"<TR><TD> </TD>"
		da	"<TD><INPUT TYPE=\"submit\" VALUE=\"Save\">"
		da	"<INPUT TYPE=\"submit\" NAME=\"INIT\" VALUE=\"Default\" ></TD></TR>"
		da	"</TABLE>"
		da	"</FORM></DL>"
		db	0
;
        ORG     0x1D00
;
		da	"<h3>Status </h3>"
		da	"<DL><DD><TABLE BORDER>"
		da	"<TR><TD>Sent Packets </TD>"
		da	"<TD>$9</TD></TR>"
		da	"<TR><TD>This IP</TD>"
		da	"<TD>$:</TD></TR>"
;		da	"<TR><TD>Socket #1</TD>"
;		da	"<TD>~\x0a</TD></TR>"
;		da	"<TR><TD>Socket #2</TD>"
;		da	"<TD>~\x0b</TD></TR>"
;		da	"<TR><TD>Socket #3</TD>"
;		da	"<TD>~\x0c</TD></TR>"
;		da	"<TR><TD>Socket #4</TD>"
;		da	"<TD>~\x0d</TD></TR>"
		da	"</TABLE></DL> "

		da	"<P><HR>Copyright (c) 2000-2001 by <A HREF=\"http://www.tristate.ne.jp\">TriState Co.,Ltd.</A> \r\n"
		da	"</BODY></HTML>"
		da	0
;
;-----------------------------------------------------------------------------------
;		EEPROM Data Init Value
;-----------------------------------------------------------------------------------
		org	1f00h
default_values_begin
		dt	192,168,0,200
		dt	255,255,255,0
		dt	0,0,0,0
		dt	1,2,0,0		; Farmware Version x,x,x,x

		dt	HTTP_PORT / 256,HTTP_PORT & 255				; HTTPݩ`ȷ
		dt	LCD_PORT / 256,LCD_PORT & 255				; LCDݩ`ȷ
		dt	PARALLEL_PORT / 256,PARALLEL_PORT & 255			; PARALLELݩ`ȷ
		dt	SERIAL_PORT / 256,SERIAL_PORT & 255			; SERIALݩ`ȷ
default_values_end

getadtable
		BSF     STATUS    , RP0
		MOVF    0x1F      , W
		BCF     STATUS    , RP0
		ANDLW   0x0F
		ADDWF   PCL       , f

		RETLW	11111111b
		RETLW	11111111b
		RETLW	00011111b
		RETLW	00011111b
		RETLW	00001011b
		RETLW	00000011b
		RETLW	00000000b
		RETLW	00000000b
		RETLW	11110011b
		RETLW	00111111b
		RETLW	00110111b
		RETLW	00110011b
		RETLW	00010011b
		RETLW	00000011b
		RETLW	00000001b
		RETLW	00000001b


mes_low		dt	" Low  ",0
mes_high	dt	" High ",0
mes_in		dt	"In ",0
mes_out		dt	"Out",0

;-----------------------------------------------------------------------------------
;		֩`ȥȥåץ`ɤΥޥɥѩ`
;-----------------------------------------------------------------------------------
get_bs_job
		ADDWF PCL,F
		dt	str_init & 0ffh,	bsj_init & 0ffh
		dt	str_init2 & 0ffh,	bsj_init & 0ffh

		dt	str_config & 0ffh,	bsj_config & 0ffh
		dt	str_config2 & 0ffh,	bsj_config & 0ffh

		dt	str_help & 0ffh,	bsj_help & 0ffh
		dt	str_help2 & 0ffh,	bsj_help & 0ffh

		dt	str_ip & 0ffh,		bsj_ip & 0ffh
		dt	str_ip2 & 0ffh,		bsj_ip & 0ffh

		dt	str_net & 0ffh,		bsj_net & 0ffh
		dt	str_net2 & 0ffh,	bsj_net & 0ffh

		dt	str_gate & 0ffh,	bsj_gate & 0ffh
		dt	str_gate2 & 0ffh,	bsj_gate & 0ffh

		dt	str_http & 0ffh,	bsj_http & 0ffh
		dt	str_http2 & 0ffh,	bsj_http & 0ffh

		dt	str_lcd & 0ffh,		bsj_lcd & 0ffh
		dt	str_lcd2 & 0ffh,	bsj_lcd & 0ffh

		dt	str_para & 0ffh,	bsj_para & 0ffh
		dt	str_para2 & 0ffh,	bsj_para & 0ffh

		dt	str_serial & 0ffh,	bsj_serial & 0ffh
		dt	str_serial2 & 0ffh,	bsj_serial & 0ffh

		dt	0,0		; Terminator


str_config	dt	"config",0
str_config2	dt	"ls",0

str_init	dt	"initialize",0
str_init2	dt	"init",0

str_help	dt	"help",0
str_help2	dt	"?",0

str_ip		dt	"ip",0
str_ip2		dt	'i',0

str_net		dt	"net",0
str_net2	dt	'n',0

str_gate	dt	"gate",0
str_gate2	dt	'g',0

str_http	dt	"http",0
str_http2	dt	'h',0

str_lcd		dt	"lcd",0
str_lcd2	dt	'l',0

str_para	dt	"parallel",0
str_para2	dt	'p',0

str_serial	dt	"serial",0
str_serial2	dt	's',0
;
        END
